searchNodes=[{"doc":"Documentation for Haytni.","ref":"Haytni.html","title":"Haytni","type":"module"},{"doc":"Notifies plugins that the authentication failed for user . If user is nil , nothing is done.","ref":"Haytni.html#authentication_failed/2","title":"Haytni.authentication_failed/2","type":"function"},{"doc":"Creates an %Ecto.Changeset{} for a new user/account (at registration from a module) or from a user (when editing account from a struct)","ref":"Haytni.html#change_user/2","title":"Haytni.change_user/2","type":"function"},{"doc":"Register user from controller's params . Returned value is one of: {:ok, map} where map is the result of the internals Ecto.Multi.* calls {:error, failed_operation, result_of_failed_operation, changes_so_far} with: failed_operation : the name of the operation which failed result_of_failed_operation : its result/returned value changes_so_far : same as map of the {:ok, map} case The inserted user will be part of map (or eventualy changes_so_far ) under the key :user . See Ecto.Repo.insert/2 for options .","ref":"Haytni.html#create_user/3","title":"Haytni.create_user/3","type":"function"},{"doc":"To delete user . This function doesn't actually do nothing except calling the Haytni.Plugin.on_delete_user/4 callbacks from the plugins in the Haytni's module stack. This way you can implement it the way you like and do extra stuffs like deleting files associated to user . See documentation of Haytni.Plugin.on_delete_user/4 for some examples.","ref":"Haytni.html#delete_user/2","title":"Haytni.delete_user/2","type":"function"},{"doc":"Function to be called, for the user, to modify its own email address: it actually updates it in the database but also invokes, first, the Haytni.Plugin.on_email_change/4 callback of the plugins registered in the module Haytni stack. Note: caller is responsible for validations against new_email_address","ref":"Haytni.html#email_changed/3","title":"Haytni.email_changed/3","type":"function"},{"doc":"Extracts an Haytni stack (module) from a Plug connection Raises if no Haytni's stack was defined (through the router).","ref":"Haytni.html#fetch_module_from_conn!/1","title":"Haytni.fetch_module_from_conn!/1","type":"function"},{"doc":"Injects Ecto.Schema.field s necessary to enabled plugins into your User schema Note that this function is invoked at compile time: you'll need to recompile your application to reflect any change related to fields injected in your user schema.","ref":"Haytni.html#fields/1","title":"Haytni.fields/1","type":"function"},{"doc":"Used by plug to extract the current user (if any) from the HTTP request (meaning from headers, cookies, etc)","ref":"Haytni.html#find_user/2","title":"Haytni.find_user/2","type":"function"},{"doc":"Fetchs a user from its id. Returns nil if no user matches. Example: case Haytni . get_user_by ( YourApp.Haytni , params [ &quot;id&quot; ] ) do nil -&gt; # not found user = % User { } -&gt; # do something of user end","ref":"Haytni.html#get_user/2","title":"Haytni.get_user/2","type":"function"},{"doc":"Fetches a user from the Ecto.Repo specified in config :haytni, YourApp.Haytni as repo subkey via the attributes specified by clauses as a map or a keyword-list. Returns nil if no user matches. Example: hulk = Haytni . get_user_by ( YourApp.Haytni , first_name : &quot;Robert&quot; , last_name : &quot;Banner&quot; )","ref":"Haytni.html#get_user_by/2","title":"Haytni.get_user_by/2","type":"function"},{"doc":"Checks if a user is valid according to plugins. Returns false if the user is valid else {:error, reason} .","ref":"Haytni.html#invalid_user?/2","title":"Haytni.invalid_user?/2","type":"function"},{"doc":"To be called on (manual) login","ref":"Haytni.html#login/4","title":"Haytni.login/4","type":"function"},{"doc":"Notifies plugins that current user is going to be logged out","ref":"Haytni.html#logout/3","title":"Haytni.logout/3","type":"function"},{"doc":"Returns true if plugin is enabled in the module Haytni stack.","ref":"Haytni.html#plugin_enabled?/2","title":"Haytni.plugin_enabled?/2","type":"function"},{"doc":"Injects the necessary routes for enabled plugins into your Router Note that this function is invoked at compile time: you'll need to recompile your application to reflect any change in your router.","ref":"Haytni.html#routes/2","title":"Haytni.routes/2","type":"function"},{"doc":"Returns the name of the assign (in Plug.Conn and templates) of the current user","ref":"Haytni.html#scoped_assign/1","title":"Haytni.scoped_assign/1","type":"function"},{"doc":"Returns the name of the session key which carries the user","ref":"Haytni.html#scoped_session_key/1","title":"Haytni.scoped_session_key/1","type":"function"},{"doc":"Get the list of shared (templates/views) or independant (Haytni stack) files to install","ref":"Haytni.html#shared_files_to_install/4","title":"Haytni.shared_files_to_install/4","type":"function"},{"doc":"","ref":"Haytni.html#stack/2","title":"Haytni.stack/2","type":"macro"},{"doc":"Update user's registration, its own registration.","ref":"Haytni.html#update_registration/4","title":"Haytni.update_registration/4","type":"function"},{"doc":"Update user in the same way as update_user_with/3 but as part of a set of operations (Ecto.Multi).","ref":"Haytni.html#update_user_in_multi_with/4","title":"Haytni.update_user_in_multi_with/4","type":"function"},{"doc":"Update the given user from a list of changes as Keyword . Returns {:error, changeset} if there was a validation or a known constraint error else {:ok, struct} where struct is the updated user. NOTE: for internal use, there isn't any validation. Do NOT inject values from controller's params !","ref":"Haytni.html#update_user_with/3","title":"Haytni.update_user_with/3","type":"function"},{"doc":"Same as update_user_with/3 but returns the updated user struct or raises if changes are invalid.","ref":"Haytni.html#update_user_with!/3","title":"Haytni.update_user_with!/3","type":"function"},{"doc":"This function is a callback to be called from your User.create_registration_changeset/2 so validations and others internal tasks can be done by plugins at user's registration.","ref":"Haytni.html#validate_create_registration/2","title":"Haytni.validate_create_registration/2","type":"function"},{"doc":"Runs any custom password validations from the plugins (via their Haytni.Plugin.validate_password/3 callback) of the module Haytni stack. An %Ecto.Changeset{} is returned with the potential validation errors added by the plugins.","ref":"Haytni.html#validate_password/2","title":"Haytni.validate_password/2","type":"function"},{"doc":"Same than validate_update_registration/3 but at registration's edition.","ref":"Haytni.html#validate_update_registration/2","title":"Haytni.validate_update_registration/2","type":"function"},{"doc":"","ref":"Haytni.html#t:config/0","title":"Haytni.config/0","type":"type"},{"doc":"","ref":"Haytni.html#t:duration/0","title":"Haytni.duration/0","type":"type"},{"doc":"","ref":"Haytni.html#t:duration_unit/0","title":"Haytni.duration_unit/0","type":"type"},{"doc":"","ref":"Haytni.html#t:irrelevant/0","title":"Haytni.irrelevant/0","type":"type"},{"doc":"","ref":"Haytni.html#t:multi_result/0","title":"Haytni.multi_result/0","type":"type"},{"doc":"","ref":"Haytni.html#t:nilable/1","title":"Haytni.nilable/1","type":"type"},{"doc":"","ref":"Haytni.html#t:params/0","title":"Haytni.params/0","type":"type"},{"doc":"","ref":"Haytni.html#t:repo_nobang_operation/1","title":"Haytni.repo_nobang_operation/1","type":"type"},{"doc":"","ref":"Haytni.html#t:user/0","title":"Haytni.user/0","type":"type"},{"doc":"","ref":"Haytni.Gettext.html","title":"Haytni.Gettext","type":"module"},{"doc":"","ref":"Haytni.Gettext.html#dgettext/1","title":"Haytni.Gettext.dgettext/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext/3 .","ref":"Haytni.Gettext.html#dgettext/3","title":"Haytni.Gettext.dgettext/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext_noop/2 .","ref":"Haytni.Gettext.html#dgettext_noop/2","title":"Haytni.Gettext.dgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext/5 .","ref":"Haytni.Gettext.html#dngettext/5","title":"Haytni.Gettext.dngettext/5","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext_noop/3 .","ref":"Haytni.Gettext.html#dngettext_noop/3","title":"Haytni.Gettext.dngettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpgettext/4 .","ref":"Haytni.Gettext.html#dpgettext/4","title":"Haytni.Gettext.dpgettext/4","type":"macro"},{"doc":"","ref":"Haytni.Gettext.html#dpgettext_noop/3","title":"Haytni.Gettext.dpgettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpngettext/6 .","ref":"Haytni.Gettext.html#dpngettext/6","title":"Haytni.Gettext.dpngettext/6","type":"macro"},{"doc":"","ref":"Haytni.Gettext.html#dpngettext_noop/4","title":"Haytni.Gettext.dpngettext_noop/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext/2 .","ref":"Haytni.Gettext.html#gettext/2","title":"Haytni.Gettext.gettext/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_comment/1 .","ref":"Haytni.Gettext.html#gettext_comment/1","title":"Haytni.Gettext.gettext_comment/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_noop/1 .","ref":"Haytni.Gettext.html#gettext_noop/1","title":"Haytni.Gettext.gettext_noop/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2 .","ref":"Haytni.Gettext.html#handle_missing_bindings/2","title":"Haytni.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/6 .","ref":"Haytni.Gettext.html#handle_missing_plural_translation/6","title":"Haytni.Gettext.handle_missing_plural_translation/6","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_translation/4 .","ref":"Haytni.Gettext.html#handle_missing_translation/4","title":"Haytni.Gettext.handle_missing_translation/4","type":"function"},{"doc":"","ref":"Haytni.Gettext.html#lgettext/5","title":"Haytni.Gettext.lgettext/5","type":"function"},{"doc":"","ref":"Haytni.Gettext.html#lngettext/7","title":"Haytni.Gettext.lngettext/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.ngettext/4 .","ref":"Haytni.Gettext.html#ngettext/4","title":"Haytni.Gettext.ngettext/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.ngettext_noop/2 .","ref":"Haytni.Gettext.html#ngettext_noop/2","title":"Haytni.Gettext.ngettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pgettext/3 .","ref":"Haytni.Gettext.html#pgettext/3","title":"Haytni.Gettext.pgettext/3","type":"macro"},{"doc":"","ref":"Haytni.Gettext.html#pgettext_noop/2","title":"Haytni.Gettext.pgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pngettext/5 .","ref":"Haytni.Gettext.html#pngettext/5","title":"Haytni.Gettext.pngettext/5","type":"macro"},{"doc":"","ref":"Haytni.Gettext.html#pngettext_noop/3","title":"Haytni.Gettext.pngettext_noop/3","type":"macro"},{"doc":"This module provides some basic helpers to query invitations to be independant and not have to know the internals of the Invitable plugin.","ref":"Haytni.InvitablePlugin.QueryHelpers.html","title":"Haytni.InvitablePlugin.QueryHelpers","type":"module"},{"doc":"Composes query to filter on accepted invitations","ref":"Haytni.InvitablePlugin.QueryHelpers.html#and_where_accepted/1","title":"Haytni.InvitablePlugin.QueryHelpers.and_where_accepted/1","type":"function"},{"doc":"Composes query for token invitation to match code","ref":"Haytni.InvitablePlugin.QueryHelpers.html#and_where_code_equals/2","title":"Haytni.InvitablePlugin.QueryHelpers.and_where_code_equals/2","type":"function"},{"doc":"Composes query for email to match the address it was sent to only if email_matching_invitation is true (else returns the query as it was)","ref":"Haytni.InvitablePlugin.QueryHelpers.html#and_where_email_equals/3","title":"Haytni.InvitablePlugin.QueryHelpers.and_where_email_equals/3","type":"function"},{"doc":"Composes query for invitation id (primary key) to worth id","ref":"Haytni.InvitablePlugin.QueryHelpers.html#and_where_id_equals/2","title":"Haytni.InvitablePlugin.QueryHelpers.and_where_id_equals/2","type":"function"},{"doc":"Composes query to filter on non-accepted invitations","ref":"Haytni.InvitablePlugin.QueryHelpers.html#and_where_not_accepted/1","title":"Haytni.InvitablePlugin.QueryHelpers.and_where_not_accepted/1","type":"function"},{"doc":"Composes query to filter on non-expired invitations","ref":"Haytni.InvitablePlugin.QueryHelpers.html#and_where_not_expired/2","title":"Haytni.InvitablePlugin.QueryHelpers.and_where_not_expired/2","type":"function"},{"doc":"Returns a queryable for all invitations Note: user is not used for the query, just to find the scope/table/association","ref":"Haytni.InvitablePlugin.QueryHelpers.html#invitations_from_all/1","title":"Haytni.InvitablePlugin.QueryHelpers.invitations_from_all/1","type":"function"},{"doc":"Returns a queryable for all invitations sent by user","ref":"Haytni.InvitablePlugin.QueryHelpers.html#invitations_from_user/1","title":"Haytni.InvitablePlugin.QueryHelpers.invitations_from_user/1","type":"function"},{"doc":"An intermediate to easily create a Bamboo email in a Phoenix way. In fact, this module is similar to Bamboo.Phoenix but I encountered some limitations and troubles to deal with views/templates path.","ref":"Haytni.Mail.html","title":"Haytni.Mail","type":"module"},{"doc":"Sets an assign for the email. These will be available when rendering the email.","ref":"Haytni.Mail.html#assign/3","title":"Haytni.Mail.assign/3","type":"function"},{"doc":"Same as put_text_template/2 but for rendering the email as HTML. NOTE: the view (see put_view/2 ) has to be set prior to a call to put_html_template/2 .","ref":"Haytni.Mail.html#put_html_template/2","title":"Haytni.Mail.put_html_template/2","type":"function"},{"doc":"Sets the template for when rendering the email as plain text. NOTE: the view (see put_view/2 ) has to be set prior to a call to put_text_template/2 .","ref":"Haytni.Mail.html#put_text_template/2","title":"Haytni.Mail.put_text_template/2","type":"function"},{"doc":"Stores the view for rendering the email.","ref":"Haytni.Mail.html#put_view/2","title":"Haytni.Mail.put_view/2","type":"function"},{"doc":"Set and infer the full name of the view for email from module and its scope. Example: if view_suffix = &quot;Email.NewLoginNotification&quot; and scope associated to module is :admin the view module is set to YourAppWeb.Admin.Email.NewLoginNotification if it exists else fallback to YourAppWeb.Email.NewLoginNotification .","ref":"Haytni.Mail.html#put_view/3","title":"Haytni.Mail.put_view/3","type":"function"},{"doc":"Regroup various helper functions specifically used by migrations","ref":"Haytni.Migration.html","title":"Haytni.Migration","type":"module"},{"doc":"Helper for migrations to choose the best type for a case insensitive string like email addresses based on the current database. Only handles PostgreSQL for now, by returning :citext instead of :string by default and try to install the citext extension if it was not already done.","ref":"Haytni.Migration.html#case_insensitive_string_type/0","title":"Haytni.Migration.case_insensitive_string_type/0","type":"function"},{"doc":"Defines a plugin to be used by Haytni","ref":"Haytni.Plugin.html","title":"Haytni.Plugin","type":"behaviour"},{"doc":"Run at compile time before embedding plugin options once for all. It is a good place to realize some pre-computations.","ref":"Haytni.Plugin.html#c:build_config/1","title":"Haytni.Plugin.build_config/1","type":"callback"},{"doc":"Returns the Ecto.Schema.field/1 s as a quoted fragment to be injected in your user schema","ref":"Haytni.Plugin.html#c:fields/1","title":"Haytni.Plugin.fields/1","type":"callback"},{"doc":"Returns a list of files to be (un)installed by the mix tasks haytni.(un)install Each file is a 3-elements tuple of the form: { format , path relative to priv/ of the file to install, path where to install the file} Format is one of the following atom : :eex : the file is an Eex template from which the content is evaluated before being copied where the following bindings are set: scope ( atom , default: :user ): unsued for now table ( String.t , default: &quot;users&quot; ): the name of the users table otp_app ( atom ): inferred, the name of the current OTP application base_module ( module ): inferred, the name of the base non-web module of your Phoenix application (the YourApp in this documentation) web_module ( module ): inferred, the name of the base web module of your Phoenix application ( YourAppWeb all over this documentation) plugins ( [module] ): the list of the enabled modules :text : to copy the file as is","ref":"Haytni.Plugin.html#c:files_to_install/4","title":"Haytni.Plugin.files_to_install/4","type":"callback"},{"doc":"Extract the user from the HTTP request (http authentication, cookies, ...). Returns a tuple of the form {conn, user} with user being nil if no user could be found at this early stage.","ref":"Haytni.Plugin.html#c:find_user/3","title":"Haytni.Plugin.find_user/3","type":"callback"},{"doc":"Check if the user is in a valid state. This callback is intended to let know others plugins if we should reject the login (and why). Returns false if the user is allowed to login else {:error, reason} where reason is a string, an informative to be directly served to the end user. For example, you may want to have some kind of ban plugin. This is the way to decline the login: def invalid? ( % User { banned : true } , _module , _config ) , do : { :error , :banned } # or: {:error, dgettext(&quot;myapp&quot;, &quot;you&#39;re banned&quot;)} def invalid? ( % User { banned : _ } , _module , _config ) , do : false","ref":"Haytni.Plugin.html#c:invalid?/3","title":"Haytni.Plugin.invalid?/3","type":"callback"},{"doc":"This callback is meant for a user to delete its own account. It could, for example, be used to soft-delete it: def on_delete_user ( multi = % Ecto.Multi { } , user = % _ { } , _module , _config ) do Ecto.Multi . update ( multi , :user , user , Ecto.Changeset . change ( user , deleted : true ) ) end Or remove associated files, like its avatar: def on_delete_user ( multi = % Ecto.Multi { } , user = % _ { } , _module , _config ) do multi # delete the user from the database |&gt; Ecto.Multi . delete ( :user_deletion , user ) # then its avatar |&gt; Ecto.Multi . run ( :avatar_deletion , fn _repo , _changes -&gt; case File . rm ( user . avatar ) do :ok -&gt; { :ok , nil } error -&gt; error end end ) end","ref":"Haytni.Plugin.html#c:on_delete_user/4","title":"Haytni.Plugin.on_delete_user/4","type":"callback"},{"doc":"This callback should be invoked when a user is editing its registration and change its email address. It returns a tuple of {Ecto.Multi, Ecto.Changeset} , same as its arguments, to permit to the callback to add any operation to multi or change to changeset . This callback is called before updating the user but the actions added to multi will be run after its update.","ref":"Haytni.Plugin.html#c:on_email_change/4","title":"Haytni.Plugin.on_email_change/4","type":"callback"},{"doc":"Invoked when an authentication failed (wrong password). It receives the concerned account (as it is before calling any on_failed_authentication callback) and a Ecto.Multi where to add any additionnal treatment and a Keyword to return after updating it if any change have to be done to this user. For example, you can use it as follows to count the number of failed attempts to login: def on_failed_authentication ( user = % _ { } , multi , keyword , _module , _config ) do { multi , Keyword . put ( keyword , :failed_attempts , user . failed_attempts + 1 ) } end Note: we choose to use and pass keyword as an accumulator to let the possibility to plugins to deal themselves on a conflict (several different plugins which want to alter a same field). Even if Keyword allows a same key to be defined several times, you'll probably don't want it to happen as the last defined value for a given key will (silently) override the others.","ref":"Haytni.Plugin.html#c:on_failed_authentication/5","title":"Haytni.Plugin.on_failed_authentication/5","type":"callback"},{"doc":"This callback is invoked when a user (manually) log out. Its purpose is mainly to do some cleanup like removing a cookie.","ref":"Haytni.Plugin.html#c:on_logout/3","title":"Haytni.Plugin.on_logout/3","type":"callback"},{"doc":"Invoked to accomplish a task right after user's registration (insert). This callback allows you to do some linked changes to the database, send an email or whatever by appending it to multi . Remember to comply to Ecto.Multi functions. In particular Ecto.Multi.run : the function called by it have to return {:ok, your value} or {:error, your value} . Also note that the inserted user will be passed to the function called by Ecto.Multi.run as the :user key to the map received by the last one as argument. The following example illustrate how to send a welcome mail: def on_registration ( multi = % Ecto.Multi { } , _module , _config ) do multi |&gt; Ecto.Multi . run ( :send_welcome_email , fn _repo , %{ user : user } -&gt; send_welcome_email_to ( user ) { :ok , true } end ) end","ref":"Haytni.Plugin.html#c:on_registration/3","title":"Haytni.Plugin.on_registration/3","type":"callback"},{"doc":"Invoked when an authentication is successful. Like on_failed_authentification/3 , it receives the current user and a Keyword to return after updating it if you want to bring any change to this user to the database. To continue our example with a failed attempts counter, on a successful authentication it may be a good idea to reset it in this scenario: def on_successful_authentication ( conn = % Plug.Conn { } , user = % _ { } , multi , keywords , _module , _config ) do { conn , multi , Keyword . put ( keywords , :failed_attempts , 0 ) } end","ref":"Haytni.Plugin.html#c:on_successful_authentication/6","title":"Haytni.Plugin.on_successful_authentication/6","type":"callback"},{"doc":"Returns the routes as a quoted fragment to be injected in application's Router","ref":"Haytni.Plugin.html#c:routes/3","title":"Haytni.Plugin.routes/3","type":"callback"},{"doc":"This callback let you do any kind of change or additionnal validation on the changeset when a user is registering.","ref":"Haytni.Plugin.html#c:validate_create_registration/3","title":"Haytni.Plugin.validate_create_registration/3","type":"callback"},{"doc":"Performs validations of user's password. It is a convenient way to enforce your password policy. Apply any custom validation(s) to the input %Ecto.Changeset{} before returning it.","ref":"Haytni.Plugin.html#c:validate_password/3","title":"Haytni.Plugin.validate_password/3","type":"callback"},{"doc":"Same as validate_create_registration but registration's edition as logic between the two may be completely different.","ref":"Haytni.Plugin.html#c:validate_update_registration/3","title":"Haytni.Plugin.validate_update_registration/3","type":"callback"},{"doc":"","ref":"Haytni.QuickViewsAndTemplatesTest.html","title":"Haytni.QuickViewsAndTemplatesTest","type":"module"},{"doc":"","ref":"Haytni.QuickViewsAndTemplatesTest.html#check_views_and_templates/2","title":"Haytni.QuickViewsAndTemplatesTest.check_views_and_templates/2","type":"function"},{"doc":"This module handles generation of tokens for the use of Haytni's plugins.","ref":"Haytni.Token.html","title":"Haytni.Token","type":"module"},{"doc":"Generates a token, associated to a given user and a given email address ( sent_to ). NOTE: this is a &quot;low level&quot; function for specific needs, the token is NOT persisted (designed to be inserted later by an Ecto.Multi). Use the higher level function insert_token_in_multi/4 if it feet your needs.","ref":"Haytni.Token.html#build_and_assoc_token/3","title":"Haytni.Token.build_and_assoc_token/3","type":"function"},{"doc":"Deletes all tokens associated to the given user and contexts (if not :all )","ref":"Haytni.Token.html#delete_tokens_in_multi/4","title":"Haytni.Token.delete_tokens_in_multi/4","type":"function"},{"doc":"When the multi will be executed, generates and inserts a token, associated to the user resulting of a previous operation of multi identified by the name user_name . Exemple: Ecto.Multi . new ( ) |&gt; Ecto.Multi . update ( :user , Ecto.Changeset . change ( user , changes ) ) |&gt; Haytni.Token . insert_token_in_multi ( :token , :user , &quot;context&quot; ) |&gt; Repo.Transaction ( )","ref":"Haytni.Token.html#insert_token_in_multi/4","title":"Haytni.Token.insert_token_in_multi/4","type":"function"},{"doc":"Generates a token associated to user and add it to the multi for later insertion.","ref":"Haytni.Token.html#insert_token_in_multi/5","title":"Haytni.Token.insert_token_in_multi/5","type":"function"},{"doc":"Generates a length long random binary token","ref":"Haytni.Token.html#new/1","title":"Haytni.Token.new/1","type":"function"},{"doc":"Purges all expired tokens. Returns the number of deleted tokens.","ref":"Haytni.Token.html#purge_expired_tokens/1","title":"Haytni.Token.purge_expired_tokens/1","type":"function"},{"doc":"Deletes all tokens associated to a given user. Returns the number of tokens that were actually deleted (expired tokens included).","ref":"Haytni.Token.html#revoke_user_tokens/2","title":"Haytni.Token.revoke_user_tokens/2","type":"function"},{"doc":"","ref":"Haytni.Token.html#token/1","title":"Haytni.Token.token/1","type":"function"},{"doc":"Helper to build the query (intended to be composed) to select all tokens associated to a given user and for the specified contexts","ref":"Haytni.Token.html#tokens_from_user_query/2","title":"Haytni.Token.tokens_from_user_query/2","type":"function"},{"doc":"Decodes a token previously encoded by url_encode/1","ref":"Haytni.Token.html#url_decode/1","title":"Haytni.Token.url_decode/1","type":"function"},{"doc":"Encodes a token to safely figure in an URL","ref":"Haytni.Token.html#url_encode/1","title":"Haytni.Token.url_encode/1","type":"function"},{"doc":"Returns the user associated to the given non-expired token, nil if none matches. This function checks that the current email address of the found user is the same than the the one associated to the token at its creation.","ref":"Haytni.Token.html#user_from_token_with_mail_match/4","title":"Haytni.Token.user_from_token_with_mail_match/4","type":"function"},{"doc":"Returns the user associated to the given non-expired token, nil if none matches but, in opposition to user_from_token_with_mail_match/4 , the email address between the user and the token is expected (has) to be different. This behaviour (and function) is primarily intended to change its email address.","ref":"Haytni.Token.html#user_from_token_without_mail_match/5","title":"Haytni.Token.user_from_token_without_mail_match/5","type":"function"},{"doc":"","ref":"Haytni.Token.html#t:t/0","title":"Haytni.Token.t/0","type":"type"},{"doc":"","ref":"Haytni.Tokenable.html","title":"Haytni.Tokenable","type":"behaviour"},{"doc":"Callback to build the query to purge expired tokens","ref":"Haytni.Tokenable.html#c:expired_tokens_query/2","title":"Haytni.Tokenable.expired_tokens_query/2","type":"callback"},{"doc":"Get the applicable context","ref":"Haytni.Tokenable.html#c:token_context/1","title":"Haytni.Tokenable.token_context/1","type":"callback"},{"doc":"This module provides some basic helpers to query connections to be independant and not have to know the internals of the Trackable plugin.","ref":"Haytni.TrackablePlugin.QueryHelpers.html","title":"Haytni.TrackablePlugin.QueryHelpers","type":"module"},{"doc":"Composes query to filter on connection between an interval","ref":"Haytni.TrackablePlugin.QueryHelpers.html#and_where_date_between/3","title":"Haytni.TrackablePlugin.QueryHelpers.and_where_date_between/3","type":"function"},{"doc":"Composes query to filter on connection date","ref":"Haytni.TrackablePlugin.QueryHelpers.html#and_where_date_equals/2","title":"Haytni.TrackablePlugin.QueryHelpers.and_where_date_equals/2","type":"function"},{"doc":"Composes query to filter on ip address","ref":"Haytni.TrackablePlugin.QueryHelpers.html#and_where_ip_equals/2","title":"Haytni.TrackablePlugin.QueryHelpers.and_where_ip_equals/2","type":"function"},{"doc":"Returns a queryable for all invitations Note: user is not used for the query, just to find the scope/table/association","ref":"Haytni.TrackablePlugin.QueryHelpers.html#connections_from_all/1","title":"Haytni.TrackablePlugin.QueryHelpers.connections_from_all/1","type":"function"},{"doc":"Returns a queryable for all connections of user","ref":"Haytni.TrackablePlugin.QueryHelpers.html#connections_from_user/1","title":"Haytni.TrackablePlugin.QueryHelpers.connections_from_user/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Haytni.Install.html","title":"Mix.Tasks.Haytni.Install","type":"task"},{"doc":"","ref":"Mix.Tasks.Haytni.Install.html#base_path/1","title":"Mix.Tasks.Haytni.Install.base_path/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Haytni.Install.html#run/1","title":"Mix.Tasks.Haytni.Install.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Haytni.Install.html#timestamp/0","title":"Mix.Tasks.Haytni.Install.timestamp/0","type":"function"},{"doc":"","ref":"Mix.Tasks.Haytni.Install.html#web_path/1","title":"Mix.Tasks.Haytni.Install.web_path/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Haytni.Uninstall.html","title":"Mix.Tasks.Haytni.Uninstall","type":"task"},{"doc":"","ref":"Mix.Tasks.Haytni.Uninstall.html#rm_from/1","title":"Mix.Tasks.Haytni.Uninstall.rm_from/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Haytni.Uninstall.html#run/1","title":"Mix.Tasks.Haytni.Uninstall.run/1","type":"function"},{"doc":"This is a base plugin as it handles basic informations of a user (which are email and hashed password) and their authentication. Fields: email (string) encrypted_password (string) Configuration: authentication_keys (default: [:email] ): the key(s), in addition to the password, requested to login. You can redefine it to ~W[name]a , for example, to ask the username instead of its email address. hashing_method (no default): a module implementing the behaviour ExPassword.Algorithm to hash and verify passwords hashing_options (a map, no default since they are hash-specific): ExPassword settings for hashing passwords To support: bcrypt: add {:expassword_bcrypt, &quot;~&gt; 0.2&quot;} in deps/0 to your mix.exs set :hashing_method to ExPassword.Bcrypt on the line stack Haytni.AuthenticablePlugin and also hashing_options: %{cost: 10} argon2: add {:expassword_argon2, &quot;~&gt; 0.2&quot;} in deps/0 to your mix.exs set :hashing_method to ExPassword.Argon2 on the line stack Haytni.AuthenticablePlugin and also hashing_options: %{type: :argon2id, threads: 2, time_cost: 4, memory_cost: 131072} stack Haytni.AuthenticablePlugin , authentication_keys : [ :email ] , hashing_method : ExPassword.Bcrypt , hashing_options : %{ cost : 10 , } Routes: haytni_&lt;scope&gt;_session_path (actions: new/create, delete): the generated routes can be customized through the following parameters when you call YourAppWeb.Haytni.routes/1: login_path (default: &quot;/session&quot; ): custom path assigned to the sign-in route logout_path (default: same value as login_path ): the path for th sign out route logout_method (default: :delete ): the HTTP method to use for the user to log out, in case where the default DELETE method were not well supported by your clients # lib/your_app_web/router.ex defmodule YourAppWeb.Router do # ... scope ... do YourAppWeb.Haytni . routes ( login_path : &quot;/login&quot; , logout_path : &quot;/logout&quot; , logout_method : :get ) end # ... end","ref":"Haytni.AuthenticablePlugin.html","title":"Haytni.AuthenticablePlugin","type":"module"},{"doc":"Authentificates a user. Returns: {:ok, user} if crendentials are correct and user is valid {:error, changeset} if credentials are incorrect or user is invalid (rejected by a Haytni.Plugin.invalid? callback by a plugin in the stack)","ref":"Haytni.AuthenticablePlugin.html#authenticate/4","title":"Haytni.AuthenticablePlugin.authenticate/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.AuthenticablePlugin.html#find_user/3","title":"Haytni.AuthenticablePlugin.find_user/3","type":"function"},{"doc":"Hashes a password. Returns the hash of the password after having hashed it","ref":"Haytni.AuthenticablePlugin.html#hash_password/2","title":"Haytni.AuthenticablePlugin.hash_password/2","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.AuthenticablePlugin.html#invalid?/3","title":"Haytni.AuthenticablePlugin.invalid?/3","type":"function"},{"doc":"The translated string to display when credentials (password and/or email by default) are wrong.","ref":"Haytni.AuthenticablePlugin.html#invalid_credentials_message/0","title":"Haytni.AuthenticablePlugin.invalid_credentials_message/0","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.AuthenticablePlugin.html#on_delete_user/4","title":"Haytni.AuthenticablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.AuthenticablePlugin.html#on_email_change/4","title":"Haytni.AuthenticablePlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.AuthenticablePlugin.html#on_failed_authentication/5","title":"Haytni.AuthenticablePlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.AuthenticablePlugin.html#on_logout/3","title":"Haytni.AuthenticablePlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.AuthenticablePlugin.html#on_registration/3","title":"Haytni.AuthenticablePlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_successful_authentication/6 .","ref":"Haytni.AuthenticablePlugin.html#on_successful_authentication/6","title":"Haytni.AuthenticablePlugin.on_successful_authentication/6","type":"function"},{"doc":"Converts the parameters received for authentication by the controller in a %Ecto.Changeset{} to handle and validate user inputs according to plugin's configuration ( authentication_keys ).","ref":"Haytni.AuthenticablePlugin.html#session_changeset/2","title":"Haytni.AuthenticablePlugin.session_changeset/2","type":"function"},{"doc":"Returns true if password matches user 's current hash ( encrypted_password field)","ref":"Haytni.AuthenticablePlugin.html#valid_password?/3","title":"Haytni.AuthenticablePlugin.valid_password?/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.AuthenticablePlugin.html#validate_password/3","title":"Haytni.AuthenticablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.AuthenticablePlugin.html#validate_update_registration/3","title":"Haytni.AuthenticablePlugin.validate_update_registration/3","type":"function"},{"doc":"The only purpose of this plugin is to handle the HTTP Clear-Site-Data header for you. Fields: none Configuration: login (default: [] ): values, as a list of binaries, to set to clear-site-data header at login logout (default: [&quot;cache&quot;, &quot;cookies&quot;, &quot;storage&quot;, &quot;executionContexts&quot;, &quot;*&quot;] ): same for logout stack Haytni.ClearSiteDataPlugin , login : [ ] , logout : :all Possible values are: [&quot;cache&quot;, &quot;cookies&quot;, &quot;storage&quot;, &quot;executionContexts&quot;, &quot;*&quot;] or the atom :all to include all of them. Routes: none","ref":"Haytni.ClearSiteDataPlugin.html","title":"Haytni.ClearSiteDataPlugin","type":"module"},{"doc":"Callback implementation for Haytni.Plugin.fields/1 .","ref":"Haytni.ClearSiteDataPlugin.html#fields/1","title":"Haytni.ClearSiteDataPlugin.fields/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.files_to_install/4 .","ref":"Haytni.ClearSiteDataPlugin.html#files_to_install/4","title":"Haytni.ClearSiteDataPlugin.files_to_install/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.ClearSiteDataPlugin.html#find_user/3","title":"Haytni.ClearSiteDataPlugin.find_user/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.ClearSiteDataPlugin.html#invalid?/3","title":"Haytni.ClearSiteDataPlugin.invalid?/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.ClearSiteDataPlugin.html#on_delete_user/4","title":"Haytni.ClearSiteDataPlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.ClearSiteDataPlugin.html#on_email_change/4","title":"Haytni.ClearSiteDataPlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.ClearSiteDataPlugin.html#on_failed_authentication/5","title":"Haytni.ClearSiteDataPlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.ClearSiteDataPlugin.html#on_registration/3","title":"Haytni.ClearSiteDataPlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.routes/3 .","ref":"Haytni.ClearSiteDataPlugin.html#routes/3","title":"Haytni.ClearSiteDataPlugin.routes/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.ClearSiteDataPlugin.html#validate_create_registration/3","title":"Haytni.ClearSiteDataPlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.ClearSiteDataPlugin.html#validate_password/3","title":"Haytni.ClearSiteDataPlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.ClearSiteDataPlugin.html#validate_update_registration/3","title":"Haytni.ClearSiteDataPlugin.validate_update_registration/3","type":"function"},{"doc":"This plugin ensure that email addresses given by users are valid by sending them an email containing an unique token that they have to return back in order to really be able to use (unlock) their account. On an email address change, it also warns the user by sending an email to the previous address and requests a confirmation, same as registering, to active in order to validate the change. Fields: confirmed_at (datetime@utc, nullable, default: NULL ): when the account was confirmed else NULL Configuration: reconfirmable (default: true ): any email changes have to be confirmed to be applied confirmation_keys (default: [:email] ): the key(s) to be matched before sending a new confirmation confirm_within (default: {3, :day} ): delay after which confirmation token is considered as expired (ie the user has to ask for a new one) stack Haytni.ConfirmablePlugin , confirm_within : { 3 , :day } , confirmation_keys : [ :email ] , reconfirmable : true , reconfirm_within : { 3 , :day } Routes: haytni_&lt;scope&gt;_confirmation_path (actions: show, new/create): default path is &quot;/confirmation&quot; but it can be redefined by the :confirmation_path option when calling YourApp.Haytni.routes/1 from your own router (eg: YourApp.Haytni.routes(confirmation_path: &quot;/verification&quot;) ) haytni_&lt;scope&gt;_reconfirmation_path (actions: show): default path is &quot;/reconfirmation&quot; (overridable by the option :reconfirmation_path )","ref":"Haytni.ConfirmablePlugin.html","title":"Haytni.ConfirmablePlugin","type":"module"},{"doc":"Confirms an account from its confirmation token . Returns {:error, reason} if token is expired or invalid else the (updated) user as {:ok, user} .","ref":"Haytni.ConfirmablePlugin.html#confirm/3","title":"Haytni.ConfirmablePlugin.confirm/3","type":"function"},{"doc":"Allows a privilegied user (administrator) to manually confirm a user. Example: you could add a route in your administration panel: scope &quot;/admin&quot; do pipe_through ~W[browser restricted_to_admin]a resources &quot;/users&quot; do resources &quot;/confirm&quot; , YourAppWeb.Admin.User.ConfirmController , singleton : true , only : ~W[update]a end end With the above controller calling this function: defmodule YourAppWeb.Admin.User.ConfirmController do def update ( conn , %{ &quot;user_id&quot; =&gt; user_id } ) do user = YourApp.UserContext . get_user! ( user_id ) { :ok , user } = Haytni.ConfirmablePlugin . confirm_user ( YourAppWeb.Haytni , user ) conn |&gt; put_flash ( :info , &quot;user has been confirmed&quot; ) |&gt; redirect ( to : Routes . admin_user_path ( conn , :index ) ) |&gt; halt ( ) end end And do the link in your templates with: Status: &lt;%= if Haytni.ConfirmablePlugin.confirmed?(user) do %&gt; Confirmed &lt;% else %&gt; Not confirmed (&lt;%= link &quot;force confirmation?&quot;, to: Routes.admin_user_confirm_path(@conn, user, :update) %&gt;) &lt;% end %&gt;","ref":"Haytni.ConfirmablePlugin.html#confirm_user/2","title":"Haytni.ConfirmablePlugin.confirm_user/2","type":"function"},{"doc":"This function converts the parameters received by the controller to request a new confirmation token sent by email to an %Ecto.Changeset{} , a convenient way to perform basic validations, any intermediate handling and casting.","ref":"Haytni.ConfirmablePlugin.html#confirmation_request_changeset/2","title":"Haytni.ConfirmablePlugin.confirmation_request_changeset/2","type":"function"},{"doc":"Has the given user been confirmed?","ref":"Haytni.ConfirmablePlugin.html#confirmed?/1","title":"Haytni.ConfirmablePlugin.confirmed?/1","type":"function"},{"doc":"The (database) attribute(s) as a keyword-list (field name: new value) to update a user as a confirmed account","ref":"Haytni.ConfirmablePlugin.html#confirmed_attributes/0","title":"Haytni.ConfirmablePlugin.confirmed_attributes/0","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.ConfirmablePlugin.html#find_user/3","title":"Haytni.ConfirmablePlugin.find_user/3","type":"function"},{"doc":"The translated string to display when (re)confirmation token is invalid (meaning matches no one)","ref":"Haytni.ConfirmablePlugin.html#invalid_token_message/0","title":"Haytni.ConfirmablePlugin.invalid_token_message/0","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.ConfirmablePlugin.html#on_delete_user/4","title":"Haytni.ConfirmablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.ConfirmablePlugin.html#on_failed_authentication/5","title":"Haytni.ConfirmablePlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.ConfirmablePlugin.html#on_logout/3","title":"Haytni.ConfirmablePlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_successful_authentication/6 .","ref":"Haytni.ConfirmablePlugin.html#on_successful_authentication/6","title":"Haytni.ConfirmablePlugin.on_successful_authentication/6","type":"function"},{"doc":"The translated string to display when account is on pending (re)confirmation.","ref":"Haytni.ConfirmablePlugin.html#pending_confirmation_message/0","title":"Haytni.ConfirmablePlugin.pending_confirmation_message/0","type":"function"},{"doc":"Reconfirms (validates an email address after its change) an account from its confirmation token . Returns {:error, reason} if token is expired or invalid else the (updated) user as {:ok, user} .","ref":"Haytni.ConfirmablePlugin.html#reconfirm/4","title":"Haytni.ConfirmablePlugin.reconfirm/4","type":"function"},{"doc":"Resend confirmation instructions to an email address (requested by its owner). Returns: {:ok, token} : a token was actualy sent by mail {:ok, nil} : there is no account matching config.confirmation_keys or the account is not pending confirmation {:error, changeset} : fields (form) was invalid","ref":"Haytni.ConfirmablePlugin.html#resend_confirmation_instructions/3","title":"Haytni.ConfirmablePlugin.resend_confirmation_instructions/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.ConfirmablePlugin.html#validate_create_registration/3","title":"Haytni.ConfirmablePlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.ConfirmablePlugin.html#validate_password/3","title":"Haytni.ConfirmablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.ConfirmablePlugin.html#validate_update_registration/3","title":"Haytni.ConfirmablePlugin.validate_update_registration/3","type":"function"},{"doc":"This plugin provides the feature of registration on invitation or sponsorship. Fields: none Configuration: invitation_quota (default: :infinity ): the maximum amount of invitation a user can send. Possible values: :infinity if illimited {count, :total} , count being a number, to restrict the user to a total of count invitation {count, :unaccepted} , count being a number, to limit the user to count pending invitation email_matching_invitation (default: false ): true to force users who accept the invitation to register with the same email address they received the invitation from invitation_required (default: true ): true if users can only register with a valid invitation. false to make it optional (sponsorship). invitation_within (default: {30, :day} ): laps of time before the invitation can no longer be used (expiration) invitation_sent_to_index_name (default: nil ): the name of the index on sent_to column if you have to explicit it stack Haytni.InvitablePlugin , invitation_required : true , invitation_quota : :infinity , invitation_within : { 30 , :day } , email_matching_invitation : false , invitation_sent_to_index_name : nil Routes: haytni_&lt;scope&gt;_invitation_path (actions: new/create): default path is &quot;/invitations&quot; but you can customize it to whatever you want by specifying the option :invitation_path to your YourApp.Haytni.routes/1 call in your router (eg: YourApp.Haytni.routes(invitation_path: &quot;/sponsorship&quot;) )","ref":"Haytni.InvitablePlugin.html","title":"Haytni.InvitablePlugin","type":"module"},{"doc":"Build an invitation associated to user . Valid attributes (keys) for attrs are: :code (required): the unique token associated to the invitation :sent_at (required): when ( DateTime ) the invitation was sent :sent_to (required): the email address the invitation was sent to :accepted_by (for testing purpose only): the id of the user who accepted the invitation :accepted_at (for testing purpose only): when ( DateTime ) the invitation was accepted :id (for testing purpose only): force a (not nil) id for an in-memory (not persisted to database) invitation","ref":"Haytni.InvitablePlugin.html#build_and_assoc_invitation/2","title":"Haytni.InvitablePlugin.build_and_assoc_invitation/2","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.InvitablePlugin.html#find_user/3","title":"Haytni.InvitablePlugin.find_user/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.InvitablePlugin.html#invalid?/3","title":"Haytni.InvitablePlugin.invalid?/3","type":"function"},{"doc":"The translated string set as error when invitation token does not exist","ref":"Haytni.InvitablePlugin.html#invalid_invitation_message/0","title":"Haytni.InvitablePlugin.invalid_invitation_message/0","type":"function"},{"doc":"The translated string set as error when email address does not match the invitation","ref":"Haytni.InvitablePlugin.html#invitation_email_mismatch_message/0","title":"Haytni.InvitablePlugin.invitation_email_mismatch_message/0","type":"function"},{"doc":"The translated string set as error when invitation has expired","ref":"Haytni.InvitablePlugin.html#invitation_expired_message/0","title":"Haytni.InvitablePlugin.invitation_expired_message/0","type":"function"},{"doc":"The translated string set as error when invitation quota is exceeded","ref":"Haytni.InvitablePlugin.html#invitation_quota_exceeded_message/1","title":"Haytni.InvitablePlugin.invitation_quota_exceeded_message/1","type":"function"},{"doc":"The translated string set as error when invitation are required but any was provided","ref":"Haytni.InvitablePlugin.html#invitation_required_message/0","title":"Haytni.InvitablePlugin.invitation_required_message/0","type":"function"},{"doc":"Converts an invitation to an Ecto.Changeset by applying the changes from params","ref":"Haytni.InvitablePlugin.html#invitation_to_changeset/3","title":"Haytni.InvitablePlugin.invitation_to_changeset/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.InvitablePlugin.html#on_delete_user/4","title":"Haytni.InvitablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.InvitablePlugin.html#on_email_change/4","title":"Haytni.InvitablePlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.InvitablePlugin.html#on_failed_authentication/5","title":"Haytni.InvitablePlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.InvitablePlugin.html#on_logout/3","title":"Haytni.InvitablePlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_successful_authentication/6 .","ref":"Haytni.InvitablePlugin.html#on_successful_authentication/6","title":"Haytni.InvitablePlugin.on_successful_authentication/6","type":"function"},{"doc":"Generates a length long random code","ref":"Haytni.InvitablePlugin.html#random_code/1","title":"Haytni.InvitablePlugin.random_code/1","type":"function"},{"doc":"Resend (email) an invitation Note: there is no checking and invitation.sender must have been preloaded","ref":"Haytni.InvitablePlugin.html#resend_information/3","title":"Haytni.InvitablePlugin.resend_information/3","type":"function"},{"doc":"Sends an invitation (by email) from user after checking if its quota ( invitation_quota ) allows it to","ref":"Haytni.InvitablePlugin.html#send_invitation/4","title":"Haytni.InvitablePlugin.send_invitation/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.InvitablePlugin.html#validate_password/3","title":"Haytni.InvitablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.InvitablePlugin.html#validate_update_registration/3","title":"Haytni.InvitablePlugin.validate_update_registration/3","type":"function"},{"doc":"","ref":"Haytni.InvitablePlugin.html#t:invitation/0","title":"Haytni.InvitablePlugin.invitation/0","type":"type"},{"doc":"This module &quot;replace&quot; the _csrf_token generated by Phoenix, if you can't use it (mainly because of caching), to recognize the current authenticated user in channels and, by extension, live view since access to session through websocket rely on this _csrf_token . To do so, this module provides a controller to deliver short lived ciphered and signed token which you request in Javascript (ajax is the main way) and send it back to the server for the websocket connection. Then, Haytni will set the current user for the websocket when you call connect/4 from your Phoenix.Socket.connect/3 callback (channels) and mount_user/4 from your c:Phoenix.LiveView.mount/3 (live view). Configuration: remote_ip_header (default: nil ): if a proxy in front of phoenix follows you the IP address of the client through a specific header, explicit it here. For example, with nginx configured with proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for; , set remote_ip_header: &quot;x-forwarded-for&quot; token_validity (default: {2, :minute} ): duration of generated token. You should keep it as short as possible (not more than few minutes) since these tokens are intended to be used right after they were requested socket_id (default: nil ): a function to resolve a user into a socket's name. This function, from a module (your Haytni's stack) and a user, should return a string (binary) that identify a socket, the same value returned by your Phoenix.Socket.id/1 callback stack Haytni.LiveViewPlugin , socket_id : nil , token_validity : { 2 , :minute } remote_ip_header : nil , Routes: haytni_&lt;scope&gt;_token_path (action: create): default path is &quot;/token&quot; but you can override it by the :token_path option when calling YourApp.Haytni.routes/1 from your router","ref":"Haytni.LiveViewPlugin.html","title":"Haytni.LiveViewPlugin","type":"module"},{"doc":"For channels, to be called in Phoenix.Socket.connect/3 callback in order to set the current user in assigns (named :current_user by default - same way as it is done for Plug.Conn). Example rejecting anonymous connections: # lib/your_app_web/channels/user_socket.ex defmodule YourAppWeb.UserSocket do @impl Phoenix.Socket def connect ( params , socket , connect_info ) do result = { :ok , socket } = Haytni.LiveViewPlugin . connect ( YourApp.Haytni , params , connect_info ) if socket . assigns . current_user do result else :error end end end","ref":"Haytni.LiveViewPlugin.html#connect/4","title":"Haytni.LiveViewPlugin.connect/4","type":"function"},{"doc":"","ref":"Haytni.LiveViewPlugin.html#connect/5","title":"Haytni.LiveViewPlugin.connect/5","type":"function"},{"doc":"Extract metadata and real token from a previously &quot;encoded&quot; token by encode_token/3","ref":"Haytni.LiveViewPlugin.html#decode_token/2","title":"Haytni.LiveViewPlugin.decode_token/2","type":"function"},{"doc":"Add metadata (IP address) to token then hash and cipher the whole.","ref":"Haytni.LiveViewPlugin.html#encode_token/3","title":"Haytni.LiveViewPlugin.encode_token/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.fields/1 .","ref":"Haytni.LiveViewPlugin.html#fields/1","title":"Haytni.LiveViewPlugin.fields/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.files_to_install/4 .","ref":"Haytni.LiveViewPlugin.html#files_to_install/4","title":"Haytni.LiveViewPlugin.files_to_install/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.LiveViewPlugin.html#find_user/3","title":"Haytni.LiveViewPlugin.find_user/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.LiveViewPlugin.html#invalid?/3","title":"Haytni.LiveViewPlugin.invalid?/3","type":"function"},{"doc":"For live view, to be called in c:Phoenix.LiveView.mount/3 callback in order to set the current user in assigns (named :current_user by default - same way as it is done for Plug.Conn). Example: # lib/your_app_web/live/your_view_live.ex defmodule YourAppWeb.YourViewLive do @impl Phoenix.LiveView def mount ( params , session , socket ) do socket = Haytni.LiveViewPlugin . mount ( YourApp.Haytni , params , session , socket ) { :ok , socket } end end","ref":"Haytni.LiveViewPlugin.html#mount/4","title":"Haytni.LiveViewPlugin.mount/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.LiveViewPlugin.html#on_delete_user/4","title":"Haytni.LiveViewPlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.LiveViewPlugin.html#on_email_change/4","title":"Haytni.LiveViewPlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.LiveViewPlugin.html#on_failed_authentication/5","title":"Haytni.LiveViewPlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.LiveViewPlugin.html#on_registration/3","title":"Haytni.LiveViewPlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_successful_authentication/6 .","ref":"Haytni.LiveViewPlugin.html#on_successful_authentication/6","title":"Haytni.LiveViewPlugin.on_successful_authentication/6","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.LiveViewPlugin.html#validate_create_registration/3","title":"Haytni.LiveViewPlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.LiveViewPlugin.html#validate_password/3","title":"Haytni.LiveViewPlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.LiveViewPlugin.html#validate_update_registration/3","title":"Haytni.LiveViewPlugin.validate_update_registration/3","type":"function"},{"doc":"This plugin locks an account after a specified number of failed sign-in attempts. User can unlock its account via email and/or after a specified time period. Fields: failed_attempts (integer, default: 0 ): the current count of successive failures to login locked_at (datetime@utc, nullable, default: NULL ): when the account was locked ( NULL while the account is not locked) Configuration: maximum_attempts (default: 20 ): the amount of successive attempts to login before locking the corresponding account unlock_keys (default: [:email] ): the field(s) to match to accept the unlock request unlock_in (default: {1, :hour} ): delay to automatically unlock the account unlock_within (default: {3, :day} ): delay after which unlock token is considered as expired (ie the user has to request a new one) unlock_strategy (default: :both ): strategy used to unlock an account. One of: :email : sends an unlock link to the user email :time : re-enables login after a certain amount of time (see :unlock_in below) :both : enables both strategies :none : no unlock strategy. You should handle unlocking by yourself. stack Haytni.LockablePlugin , maximum_attempts : 20 , unlock_in : { 1 , :hour } , unlock_within : { 3 , :day } , unlock_strategy : :both , unlock_keys : [ :email ] Routes: haytni_&lt;scope&gt;_unlock_path (actions: new/create, show): default path is &quot;/unlock&quot; but you can override it by the :unlock_path option when calling YourApp.Haytni.routes/1 from your router (eg: YourApp.Haytni.routes(unlock_path: &quot;/unblock&quot;) )","ref":"Haytni.LockablePlugin.html","title":"Haytni.LockablePlugin","type":"module"},{"doc":"The translated string to display when email strategy is switched off for someone who would want to request an unlock token or have previously received one by email.","ref":"Haytni.LockablePlugin.html#email_strategy_disabled_message/0","title":"Haytni.LockablePlugin.email_strategy_disabled_message/0","type":"function"},{"doc":"Returns true if :email strategy (included in :both ) is enabled","ref":"Haytni.LockablePlugin.html#email_strategy_enabled?/1","title":"Haytni.LockablePlugin.email_strategy_enabled?/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.LockablePlugin.html#find_user/3","title":"Haytni.LockablePlugin.find_user/3","type":"function"},{"doc":"The translated string to display when an unlock token is invalid (ie not associated to someone)","ref":"Haytni.LockablePlugin.html#invalid_token_message/0","title":"Haytni.LockablePlugin.invalid_token_message/0","type":"function"},{"doc":"Returns true if it's the last attempt before account locking in case of a new sign-in failure","ref":"Haytni.LockablePlugin.html#last_attempt?/2","title":"Haytni.LockablePlugin.last_attempt?/2","type":"function"},{"doc":"The (database) attributes as a keyword-list to turn a user as a locked account","ref":"Haytni.LockablePlugin.html#lock_attributes/0","title":"Haytni.LockablePlugin.lock_attributes/0","type":"function"},{"doc":"Allows a privilegied user (administrator) to manually lock a user.","ref":"Haytni.LockablePlugin.html#lock_user/2","title":"Haytni.LockablePlugin.lock_user/2","type":"function"},{"doc":"Returns true if user account is currently locked.","ref":"Haytni.LockablePlugin.html#locked?/2","title":"Haytni.LockablePlugin.locked?/2","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.LockablePlugin.html#on_delete_user/4","title":"Haytni.LockablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.LockablePlugin.html#on_email_change/4","title":"Haytni.LockablePlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.LockablePlugin.html#on_logout/3","title":"Haytni.LockablePlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.LockablePlugin.html#on_registration/3","title":"Haytni.LockablePlugin.on_registration/3","type":"function"},{"doc":"Resend, by email, the instructions to unlock an account. Returns: {:ok, nil} : no one matches config.unlock_keys or the account is not currently locked {:ok, user} : an email has been sent {:error, changeset} : form fields are invalid (empty) or :email (reminder: included by :both ) strategy is disabled","ref":"Haytni.LockablePlugin.html#resend_unlock_instructions/3","title":"Haytni.LockablePlugin.resend_unlock_instructions/3","type":"function"},{"doc":"Unlock an account from a URL base64 encoded unlock token. Returns the user as {:ok, user} if the token exists and {:error, message} if not.","ref":"Haytni.LockablePlugin.html#unlock/3","title":"Haytni.LockablePlugin.unlock/3","type":"function"},{"doc":"The (database) attributes as a keyword-list to turn an account to unlocked state","ref":"Haytni.LockablePlugin.html#unlock_attributes/0","title":"Haytni.LockablePlugin.unlock_attributes/0","type":"function"},{"doc":"Converts the &quot;raw&quot; parameters received by the controller to request a new token to unlock its account to an %Ecto.Changeset{}","ref":"Haytni.LockablePlugin.html#unlock_request_changeset/2","title":"Haytni.LockablePlugin.unlock_request_changeset/2","type":"function"},{"doc":"Allows a privilegied user (administrator) to manually unlock a user.","ref":"Haytni.LockablePlugin.html#unlock_user/2","title":"Haytni.LockablePlugin.unlock_user/2","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.LockablePlugin.html#validate_create_registration/3","title":"Haytni.LockablePlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.LockablePlugin.html#validate_password/3","title":"Haytni.LockablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.LockablePlugin.html#validate_update_registration/3","title":"Haytni.LockablePlugin.validate_update_registration/3","type":"function"},{"doc":"This plugin provides a basic password policy based on its length and its content (character types). If you are looking for a more advanced policy you'll probably want to disable this plugin and write your own. Fields: none Configuration: password_length (default: 6..128 ): define min and max password length as an Elixir Range. It's worth noting, if you use bcrypt to hash passwords, that there is no point to allow a length beyond 72 bytes because bcrypt silently truncates keys to this length. password_classes_to_match (default: 2 ): the minimum character classes between digit, lowercase, uppercase and others a password has to match to be accepted stack Haytni.PasswordPolicyPlugin , password_length : 6 .. 128 , password_classes_to_match : 2 Routes: none","ref":"Haytni.PasswordPolicyPlugin.html","title":"Haytni.PasswordPolicyPlugin","type":"module"},{"doc":"Callback implementation for Haytni.Plugin.fields/1 .","ref":"Haytni.PasswordPolicyPlugin.html#fields/1","title":"Haytni.PasswordPolicyPlugin.fields/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.files_to_install/4 .","ref":"Haytni.PasswordPolicyPlugin.html#files_to_install/4","title":"Haytni.PasswordPolicyPlugin.files_to_install/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.PasswordPolicyPlugin.html#find_user/3","title":"Haytni.PasswordPolicyPlugin.find_user/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.PasswordPolicyPlugin.html#invalid?/3","title":"Haytni.PasswordPolicyPlugin.invalid?/3","type":"function"},{"doc":"The translated string to display when the password doesn't contain at least config.password_classes_to_match different types of characters in it.","ref":"Haytni.PasswordPolicyPlugin.html#invalid_password_format_message/1","title":"Haytni.PasswordPolicyPlugin.invalid_password_format_message/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.PasswordPolicyPlugin.html#on_delete_user/4","title":"Haytni.PasswordPolicyPlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.PasswordPolicyPlugin.html#on_email_change/4","title":"Haytni.PasswordPolicyPlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.PasswordPolicyPlugin.html#on_failed_authentication/5","title":"Haytni.PasswordPolicyPlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.PasswordPolicyPlugin.html#on_logout/3","title":"Haytni.PasswordPolicyPlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.PasswordPolicyPlugin.html#on_registration/3","title":"Haytni.PasswordPolicyPlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_successful_authentication/6 .","ref":"Haytni.PasswordPolicyPlugin.html#on_successful_authentication/6","title":"Haytni.PasswordPolicyPlugin.on_successful_authentication/6","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.routes/3 .","ref":"Haytni.PasswordPolicyPlugin.html#routes/3","title":"Haytni.PasswordPolicyPlugin.routes/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.PasswordPolicyPlugin.html#validate_create_registration/3","title":"Haytni.PasswordPolicyPlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.PasswordPolicyPlugin.html#validate_update_registration/3","title":"Haytni.PasswordPolicyPlugin.validate_update_registration/3","type":"function"},{"doc":"This plugin allows the user to reset its password if he forgot it. To do so, its email addresse (default) is asked to him then an unique token is generated and send to its mailbox. This mail contains a link to activate where a new password will be requested to override the previous one. Fields: none Configuration: reset_password_within (default: {6, :hour} ): the delay before the token expires reset_password_keys (default: [:email] ): the field(s) to be matched to send a reinitialization token stack Haytni.RecoverablePlugin , reset_password_keys : [ :email ] , reset_password_within : { 6 , :hour } Routes: haytni_&lt;scope&gt;_password_path (actions: new/create, edit/update): default path is &quot;/password&quot; but you can customize it to whatever you want by specifying the option :password_path to your YourApp.Haytni.routes/1 call in your router (eg: YourApp.Haytni.routes(password_path: &quot;/recover&quot;) )","ref":"Haytni.RecoverablePlugin.html","title":"Haytni.RecoverablePlugin","type":"module"},{"doc":"Callback implementation for Haytni.Plugin.fields/1 .","ref":"Haytni.RecoverablePlugin.html#fields/1","title":"Haytni.RecoverablePlugin.fields/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.RecoverablePlugin.html#find_user/3","title":"Haytni.RecoverablePlugin.find_user/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.RecoverablePlugin.html#invalid?/3","title":"Haytni.RecoverablePlugin.invalid?/3","type":"function"},{"doc":"The translated string to display when a password recovery token is invalid (ie not associated to someone)","ref":"Haytni.RecoverablePlugin.html#invalid_token_message/0","title":"Haytni.RecoverablePlugin.invalid_token_message/0","type":"function"},{"doc":"The (database) attributes as a keyword-list to redefine the password (after hashing) and void previous password recovery token","ref":"Haytni.RecoverablePlugin.html#new_password_attributes/2","title":"Haytni.RecoverablePlugin.new_password_attributes/2","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.RecoverablePlugin.html#on_delete_user/4","title":"Haytni.RecoverablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.RecoverablePlugin.html#on_email_change/4","title":"Haytni.RecoverablePlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.RecoverablePlugin.html#on_failed_authentication/5","title":"Haytni.RecoverablePlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.RecoverablePlugin.html#on_logout/3","title":"Haytni.RecoverablePlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.RecoverablePlugin.html#on_registration/3","title":"Haytni.RecoverablePlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_successful_authentication/6 .","ref":"Haytni.RecoverablePlugin.html#on_successful_authentication/6","title":"Haytni.RecoverablePlugin.on_successful_authentication/6","type":"function"},{"doc":"Change user's password from its recovering token. Returns {:ok, user} if successful else {:error, changeset} when the token: is empty doesn't exist is expired","ref":"Haytni.RecoverablePlugin.html#recover/3","title":"Haytni.RecoverablePlugin.recover/3","type":"function"},{"doc":"Converts the parameters received by the controller from which users can start the password recovery procedure by requesting a recovery token into an %Ecto.Changeset{} .","ref":"Haytni.RecoverablePlugin.html#recovering_changeset/2","title":"Haytni.RecoverablePlugin.recovering_changeset/2","type":"function"},{"doc":"Send instructions to reset user's password. Returns: {:error, changeset} if fields (form) were not filled {:ok, nil} if there is no account matching config.reset_password_keys {:ok, token} if successful","ref":"Haytni.RecoverablePlugin.html#send_reset_password_instructions/3","title":"Haytni.RecoverablePlugin.send_reset_password_instructions/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.RecoverablePlugin.html#validate_create_registration/3","title":"Haytni.RecoverablePlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.RecoverablePlugin.html#validate_password/3","title":"Haytni.RecoverablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.RecoverablePlugin.html#validate_update_registration/3","title":"Haytni.RecoverablePlugin.validate_update_registration/3","type":"function"},{"doc":"This plugin allows the user to register and edit their account. Change your_app /lib/ your_app /user.ex to add two functions: create_registration_changeset and update_registration_changeset . Example: defmodule YourApp.User do require YourApp.Haytni @derive { Inspect , except : [ :password ] } schema &quot;users&quot; do YourApp.Haytni . fields ( ) # ... end # ... # called when a user try to register himself def create_registration_changeset ( % __MODULE__ { } = struct , params ) do struct |&gt; cast ( params , ~W[email password]a ) # add any field you&#39;ll may need (but only fields that user is allowed to define!) |&gt; YourApp.Haytni . validate_password ( ) # add any custom validation here |&gt; YourApp.Haytni . validate_create_registration ( ) end # called when a user try to edit its own account (logic is completely different) def update_registration_changeset ( % __MODULE__ { } = struct , params ) do struct |&gt; cast ( params , ~W[]a ) # add any field in the list you&#39;ll may need (but only fields that user is allowed to redefine!) # add any custom validation here |&gt; YourApp.Haytni . validate_update_registration ( ) end # ... end Fields: none Configuration: email_regexp (default: ~r/^[^@\\s]+@[^@\\s]+$/ ): the Regex that an email at registration or profile edition needs to match case_insensitive_keys (default: [:email] ): list of fields to automatically downcase on registration. May be unneeded depending on your database (eg: citext columns for PostgreSQL or columns with a collation suffixed by &quot;_ci&quot; for MySQL). You SHOULD NOT include the password field here! strip_whitespace_keys (default: [:email] ): list of fields to automatically strip from whitespaces. You SHOULD NEITHER include the password field here, to exclude any involuntary mistake, you should instead consider using a custom validation. email_index_name (default: nil , translated to &lt;source&gt;_email_index by Ecto.Changeset.unique_constraint/3 ): the name of the unique index/constraint on email field registration_disabled? (default: false ): disable any new registration (existing users are still able to login, edit their profile, ...) with_delete (default: false ): true to allow users to delete their own account (this mainly (en|dis)ables the route to reach the delete action of the HaytniWeb.Registerable.RegistrationController controller) logout_on_deletion (default: true ): when true the user is also logged out. Set it to false if the user should keep its session active and navigating as this user stack Haytni.RegisterablePlugin , registration_disabled? : false , strip_whitespace_keys : [ :email ] , case_insensitive_keys : [ :email ] , email_regexp : ~r/^[^@ \\s ]+@[^@ \\s ]+$/ , email_index_name : nil Routes: haytni_&lt;scope&gt;_registration_path (actions: new/create, edit/update): paths used by the generated routes for this plugin can be customized on YourAppWeb.Haytni.routes/1 call in your router by the following options: registration_path (default: &quot;/registration&quot; ): the base/default path for all the actions new_registration_path (default: registration_path &lt;&gt; &quot;/new&quot; ): define this option to define a specific path for the new action (sign up/account creation) edit_registration_path (default: registration_path &lt;&gt; &quot;/edit&quot; ): same for edit action (profile edition)","ref":"Haytni.RegisterablePlugin.html","title":"Haytni.RegisterablePlugin","type":"module"},{"doc":"Downcase values of a changeset to keys configured as case_insensitive_keys","ref":"Haytni.RegisterablePlugin.html#case_insensitive_changes/2","title":"Haytni.RegisterablePlugin.case_insensitive_changes/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} to delete its own account.","ref":"Haytni.RegisterablePlugin.html#change_deletion/4","title":"Haytni.RegisterablePlugin.change_deletion/4","type":"function"},{"doc":"Returns an %Ecto.Changeset{} to modify its email address.","ref":"Haytni.RegisterablePlugin.html#change_email/4","title":"Haytni.RegisterablePlugin.change_email/4","type":"function"},{"doc":"Returns an %Ecto.Changeset{} to modify its password.","ref":"Haytni.RegisterablePlugin.html#change_password/3","title":"Haytni.RegisterablePlugin.change_password/3","type":"function"},{"doc":"Triggers user 's account deletion, by calling Haytni.delete_user/2 , if current_password matches user 's password. Returns the result of Haytni.delete_user/2 or {:error, :validation_failed, %Ecto.Changeset{}, %{}} if current_password is incorrect and/or user has not accepted the terms","ref":"Haytni.RegisterablePlugin.html#delete_account/5","title":"Haytni.RegisterablePlugin.delete_account/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.fields/1 .","ref":"Haytni.RegisterablePlugin.html#fields/1","title":"Haytni.RegisterablePlugin.fields/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.RegisterablePlugin.html#find_user/3","title":"Haytni.RegisterablePlugin.find_user/3","type":"function"},{"doc":"The translated string to display when email hasn't changed","ref":"Haytni.RegisterablePlugin.html#has_not_changed_message/0","title":"Haytni.RegisterablePlugin.has_not_changed_message/0","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.RegisterablePlugin.html#invalid?/3","title":"Haytni.RegisterablePlugin.invalid?/3","type":"function"},{"doc":"The translated string to display when user's current password is incorrect","ref":"Haytni.RegisterablePlugin.html#invalid_current_password_message/0","title":"Haytni.RegisterablePlugin.invalid_current_password_message/0","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.RegisterablePlugin.html#on_delete_user/4","title":"Haytni.RegisterablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.RegisterablePlugin.html#on_email_change/4","title":"Haytni.RegisterablePlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.RegisterablePlugin.html#on_failed_authentication/5","title":"Haytni.RegisterablePlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.RegisterablePlugin.html#on_logout/3","title":"Haytni.RegisterablePlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.RegisterablePlugin.html#on_registration/3","title":"Haytni.RegisterablePlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_successful_authentication/6 .","ref":"Haytni.RegisterablePlugin.html#on_successful_authentication/6","title":"Haytni.RegisterablePlugin.on_successful_authentication/6","type":"function"},{"doc":"Trim values of a changeset to keys configured as strip_whitespace_keys","ref":"Haytni.RegisterablePlugin.html#strip_whitespace_changes/2","title":"Haytni.RegisterablePlugin.strip_whitespace_changes/2","type":"function"},{"doc":"Updates user 's email address if current_password matches user 's actual password.","ref":"Haytni.RegisterablePlugin.html#update_email/5","title":"Haytni.RegisterablePlugin.update_email/5","type":"function"},{"doc":"Updates user 's password if: current_password matches user 's actual password the new password meets the requirements against the active plugins implementing the Haytni.Plugin.validate_password/3 callback When the password is changed, the tokens associated to user are also deleted.","ref":"Haytni.RegisterablePlugin.html#update_password/4","title":"Haytni.RegisterablePlugin.update_password/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.RegisterablePlugin.html#validate_password/3","title":"Haytni.RegisterablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.RegisterablePlugin.html#validate_update_registration/3","title":"Haytni.RegisterablePlugin.validate_update_registration/3","type":"function"},{"doc":"This plugin makes artificialy last user's authentication by creating a cookie which stores a token for remembering the user. This cookie is cleared when user's manually logout. Configuration: remember_for (default: {2, :week} ): the period of validity of the token/which the user won't be asked for credentials remember_cookie_name (default: &quot;remember_token&quot; ): the name of the cookie holding the token for automatic sign in remember_cookie_options (default: [http_only: true, extra: &quot;SameSite=Strict&quot;] ): to set custom options of the cookie (options are: domain , max_age , path , http_only , secure and extra , see documentation of Plug.Conn.put_resp_cookie/4 ) stack Haytni.RememberablePlugin , remember_for : { 2 , :week } , remember_cookie_name : &quot;remember_token&quot; , remember_cookie_options : [ http_only : true , extra : &quot;SameSite=Strict&quot; ] Routes: none","ref":"Haytni.RememberablePlugin.html","title":"Haytni.RememberablePlugin","type":"module"},{"doc":"Sign remember_token then add it to conn response's cookies. Returns the updated %Plug.Conn{} with our rememberme cookie","ref":"Haytni.RememberablePlugin.html#add_rememberme_cookie/3","title":"Haytni.RememberablePlugin.add_rememberme_cookie/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.fields/1 .","ref":"Haytni.RememberablePlugin.html#fields/1","title":"Haytni.RememberablePlugin.fields/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.files_to_install/4 .","ref":"Haytni.RememberablePlugin.html#files_to_install/4","title":"Haytni.RememberablePlugin.files_to_install/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.RememberablePlugin.html#invalid?/3","title":"Haytni.RememberablePlugin.invalid?/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.RememberablePlugin.html#on_delete_user/4","title":"Haytni.RememberablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.RememberablePlugin.html#on_email_change/4","title":"Haytni.RememberablePlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.RememberablePlugin.html#on_failed_authentication/5","title":"Haytni.RememberablePlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.RememberablePlugin.html#on_registration/3","title":"Haytni.RememberablePlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.routes/3 .","ref":"Haytni.RememberablePlugin.html#routes/3","title":"Haytni.RememberablePlugin.routes/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.RememberablePlugin.html#validate_create_registration/3","title":"Haytni.RememberablePlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.RememberablePlugin.html#validate_password/3","title":"Haytni.RememberablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.RememberablePlugin.html#validate_update_registration/3","title":"Haytni.RememberablePlugin.validate_update_registration/3","type":"function"},{"doc":"This module keeps tracks of the following elements: the remote address IP used by the client at each of its sign in (in a table apart) when he lastly signed in To do so a new module will be dynamically created by suffixing &quot;Connection&quot; to the module of your user's schema (eg: YourApp.User =&gt; YourApp.UserConnection) Fields: last_sign_in_at (datetime@utc, nullable, default: NULL ): date/time when the current session was started, nil if the user has never signed in current_sign_in_at (datetime@utc, nullable, default: NULL ): date/time when the previous session was started, nil if the user has never signed in at least twice Note that the previous fields can be nil , don't forget to handle this specific case! Configuration: none Routes: none","ref":"Haytni.TrackablePlugin.html","title":"Haytni.TrackablePlugin","type":"module"},{"doc":"Callback implementation for Haytni.Plugin.build_config/1 .","ref":"Haytni.TrackablePlugin.html#build_config/1","title":"Haytni.TrackablePlugin.build_config/1","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.find_user/3 .","ref":"Haytni.TrackablePlugin.html#find_user/3","title":"Haytni.TrackablePlugin.find_user/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.invalid?/3 .","ref":"Haytni.TrackablePlugin.html#invalid?/3","title":"Haytni.TrackablePlugin.invalid?/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_delete_user/4 .","ref":"Haytni.TrackablePlugin.html#on_delete_user/4","title":"Haytni.TrackablePlugin.on_delete_user/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_email_change/4 .","ref":"Haytni.TrackablePlugin.html#on_email_change/4","title":"Haytni.TrackablePlugin.on_email_change/4","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_failed_authentication/5 .","ref":"Haytni.TrackablePlugin.html#on_failed_authentication/5","title":"Haytni.TrackablePlugin.on_failed_authentication/5","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_logout/3 .","ref":"Haytni.TrackablePlugin.html#on_logout/3","title":"Haytni.TrackablePlugin.on_logout/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.on_registration/3 .","ref":"Haytni.TrackablePlugin.html#on_registration/3","title":"Haytni.TrackablePlugin.on_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.routes/3 .","ref":"Haytni.TrackablePlugin.html#routes/3","title":"Haytni.TrackablePlugin.routes/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_create_registration/3 .","ref":"Haytni.TrackablePlugin.html#validate_create_registration/3","title":"Haytni.TrackablePlugin.validate_create_registration/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_password/3 .","ref":"Haytni.TrackablePlugin.html#validate_password/3","title":"Haytni.TrackablePlugin.validate_password/3","type":"function"},{"doc":"Callback implementation for Haytni.Plugin.validate_update_registration/3 .","ref":"Haytni.TrackablePlugin.html#validate_update_registration/3","title":"Haytni.TrackablePlugin.validate_update_registration/3","type":"function"},{"doc":"","ref":"Haytni.AuthenticablePlugin.Config.html","title":"Haytni.AuthenticablePlugin.Config","type":"module"},{"doc":"","ref":"Haytni.AuthenticablePlugin.Config.html#t:t/0","title":"Haytni.AuthenticablePlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.ConfirmableEmail.html","title":"Haytni.ConfirmableEmail","type":"module"},{"doc":"The confirmation request sent by email at registration","ref":"Haytni.ConfirmableEmail.html#confirmation_email/4","title":"Haytni.ConfirmableEmail.confirmation_email/4","type":"function"},{"doc":"When email address is modified, send a notice of this change to the user on its previous email address","ref":"Haytni.ConfirmableEmail.html#email_changed/4","title":"Haytni.ConfirmableEmail.email_changed/4","type":"function"},{"doc":"The reconfirmation request sent by email when the user change the email address of its own account","ref":"Haytni.ConfirmableEmail.html#reconfirmation_email/5","title":"Haytni.ConfirmableEmail.reconfirmation_email/5","type":"function"},{"doc":"","ref":"Haytni.ConfirmablePlugin.Config.html","title":"Haytni.ConfirmablePlugin.Config","type":"module"},{"doc":"","ref":"Haytni.ConfirmablePlugin.Config.html#t:t/0","title":"Haytni.ConfirmablePlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.LockableEmail.html","title":"Haytni.LockableEmail","type":"module"},{"doc":"Email the token to unlock user account","ref":"Haytni.LockableEmail.html#unlock_instructions_email/4","title":"Haytni.LockableEmail.unlock_instructions_email/4","type":"function"},{"doc":"","ref":"Haytni.LockablePlugin.Config.html","title":"Haytni.LockablePlugin.Config","type":"module"},{"doc":"Returns all available strategies (all possible values for unlock_strategy parameter)","ref":"Haytni.LockablePlugin.Config.html#available_strategies/0","title":"Haytni.LockablePlugin.Config.available_strategies/0","type":"function"},{"doc":"Returns strategies involving sending emails","ref":"Haytni.LockablePlugin.Config.html#email_strategies/0","title":"Haytni.LockablePlugin.Config.email_strategies/0","type":"function"},{"doc":"","ref":"Haytni.LockablePlugin.Config.html#t:t/0","title":"Haytni.LockablePlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.LockablePlugin.Config.html#t:unlock_strategy/0","title":"Haytni.LockablePlugin.Config.unlock_strategy/0","type":"type"},{"doc":"","ref":"Haytni.Recoverable.PasswordChange.html","title":"Haytni.Recoverable.PasswordChange","type":"module"},{"doc":"","ref":"Haytni.Recoverable.PasswordChange.html#change_password/2","title":"Haytni.Recoverable.PasswordChange.change_password/2","type":"function"},{"doc":"","ref":"Haytni.Recoverable.PasswordChange.html#changeset/3","title":"Haytni.Recoverable.PasswordChange.changeset/3","type":"function"},{"doc":"","ref":"Haytni.Recoverable.PasswordChange.html#t:t/0","title":"Haytni.Recoverable.PasswordChange.t/0","type":"type"},{"doc":"","ref":"Haytni.RecoverableEmail.html","title":"Haytni.RecoverableEmail","type":"module"},{"doc":"Email the recovery password token to user","ref":"Haytni.RecoverableEmail.html#reset_password_email/4","title":"Haytni.RecoverableEmail.reset_password_email/4","type":"function"},{"doc":"","ref":"Haytni.RecoverablePlugin.Config.html","title":"Haytni.RecoverablePlugin.Config","type":"module"},{"doc":"","ref":"Haytni.RecoverablePlugin.Config.html#t:t/0","title":"Haytni.RecoverablePlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.RegisterablePlugin.Config.html","title":"Haytni.RegisterablePlugin.Config","type":"module"},{"doc":"","ref":"Haytni.RegisterablePlugin.Config.html#t:t/0","title":"Haytni.RegisterablePlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.PasswordPolicyPlugin.Config.html","title":"Haytni.PasswordPolicyPlugin.Config","type":"module"},{"doc":"","ref":"Haytni.PasswordPolicyPlugin.Config.html#t:t/0","title":"Haytni.PasswordPolicyPlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.RememberablePlugin.Config.html","title":"Haytni.RememberablePlugin.Config","type":"module"},{"doc":"","ref":"Haytni.RememberablePlugin.Config.html#t:t/0","title":"Haytni.RememberablePlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.InvitableEmail.html","title":"Haytni.InvitableEmail","type":"module"},{"doc":"Email an invitation In the invitation templates, user is the sender of the invitation, you have full access to it, so you can use any field from its schema so you can refer to it by its surname if you like.","ref":"Haytni.InvitableEmail.html#invitation_email/4","title":"Haytni.InvitableEmail.invitation_email/4","type":"function"},{"doc":"","ref":"Haytni.InvitablePlugin.Config.html","title":"Haytni.InvitablePlugin.Config","type":"module"},{"doc":"","ref":"Haytni.InvitablePlugin.Config.html#t:t/0","title":"Haytni.InvitablePlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.LiveViewPlugin.Config.html","title":"Haytni.LiveViewPlugin.Config","type":"module"},{"doc":"","ref":"Haytni.LiveViewPlugin.Config.html#t:t/0","title":"Haytni.LiveViewPlugin.Config.t/0","type":"type"},{"doc":"","ref":"Haytni.ClearSiteDataPlugin.Config.html","title":"Haytni.ClearSiteDataPlugin.Config","type":"module"},{"doc":"","ref":"Haytni.ClearSiteDataPlugin.Config.html#t:t/0","title":"Haytni.ClearSiteDataPlugin.Config.t/0","type":"type"},{"doc":"Regroup various helper functions that are not directly tied to the web part (mostly for plugins use but not in controllers, views or templates).","ref":"Haytni.Helpers.html","title":"Haytni.Helpers","type":"module"},{"doc":"Helper to add a global error under the :base key as Ruby on Rails does.","ref":"Haytni.Helpers.html#add_base_error/2","title":"Haytni.Helpers.add_base_error/2","type":"function"},{"doc":"Helper to add a global error under the :base key as Ruby on Rails does and right after apply (see Ecto.Changeset.apply_action/2 ) an action. Meaning the changeset is not meant to be reuse (you had better to use add_base_error/2 instead), it is an immediate error.","ref":"Haytni.Helpers.html#apply_base_error/2","title":"Haytni.Helpers.apply_base_error/2","type":"function"},{"doc":"Concat to message the translated note to invite the user to also check its spam folder","ref":"Haytni.Helpers.html#concat_spam_check_hint_message/1","title":"Haytni.Helpers.concat_spam_check_hint_message/1","type":"function"},{"doc":"Convert a duration of the form {number, unit} to seconds. unit can be one of the following: :second :minute :hour :day :week :month :year","ref":"Haytni.Helpers.html#duration/1","title":"Haytni.Helpers.duration/1","type":"function"},{"doc":"Helper for plugins to associate a mismatch error to fields given as keys of changeset . Returns an Ecto.Changeset.t with proper errors set.","ref":"Haytni.Helpers.html#mark_changeset_keys_as_unmatched/2","title":"Haytni.Helpers.mark_changeset_keys_as_unmatched/2","type":"function"},{"doc":"Add the given error to all keys fields in changeset and returns the resulting as an error tuple ( {:error, %Ecto.Changeset{}} )","ref":"Haytni.Helpers.html#mark_changeset_keys_with_error/3","title":"Haytni.Helpers.mark_changeset_keys_with_error/3","type":"function"},{"doc":"Helper intended for plugins for the implementation of their build_config/1 callback. It merges the values of params into struct , their default configuration and automatically converting duration_keys from Haytni.duration to seconds.","ref":"Haytni.Helpers.html#merge_config/3","title":"Haytni.Helpers.merge_config/3","type":"function"},{"doc":"","ref":"Haytni.Helpers.html#multi_to_regular_result/2","title":"Haytni.Helpers.multi_to_regular_result/2","type":"macro"},{"doc":"The translated string set as error when a key/field doesn't match any account","ref":"Haytni.Helpers.html#no_match_message/0","title":"Haytni.Helpers.no_match_message/0","type":"function"},{"doc":"Helper to return the current UTC datetime as expected by :utc_datetime type of Ecto (meaning a %DateTime{} without microseconds).","ref":"Haytni.Helpers.html#now/0","title":"Haytni.Helpers.now/0","type":"function"},{"doc":"Generates a module name by appending suffix to module iex&gt; Elixir.Haytni.Helpers . scope_module ( YourApp.User , &quot;Connection&quot; ) YourApp.UserConnection","ref":"Haytni.Helpers.html#scope_module/2","title":"Haytni.Helpers.scope_module/2","type":"function"},{"doc":"Casts the parameters received by a controller (a map of strings - as both keys and values) to a %Ecto.Changeset{} . This transformation is done by casting all values for keys to string and optionaly requiring (validation) the presence of required_keys . If required_keys is nil , all keys are mandatory.","ref":"Haytni.Helpers.html#to_changeset/4","title":"Haytni.Helpers.to_changeset/4","type":"function"},{"doc":"Convenient functions to build the params Map (parameters for the HTTP request) in tests","ref":"Haytni.Params.html","title":"Haytni.Params","type":"module"},{"doc":"Adds the confirmation keys to the map params by copying the values of the given keys under the same suffixed by &quot;_confirmation&quot;. Example: iex&gt; Elixir.Haytni.Params . confirm ( %{ &quot;email&quot; =&gt; &quot;foo@bar.com&quot; , &quot;password&quot; =&gt; &quot;azerty&quot; , ~W[password]a } %{ &quot;email&quot; =&gt; &quot;foo@bar.com&quot; , &quot;password&quot; =&gt; &quot;azerty&quot; , &quot;password_confirmation&quot; =&gt; &quot;azerty&quot; }","ref":"Haytni.Params.html#confirm/2","title":"Haytni.Params.confirm/2","type":"function"},{"doc":"Creates parameters (a map of string as keys and values) by merging attrs into defaults . NOTES: defaults has to contain all the necessary keys because, in order to accept struct as attrs the extra keys of attrs are dropped all keys are stringified for convenience/reduce boilerplate if a value in attrs is a function (of 1-arity), it will be called with the corresponding value of defaults to set the final value nil values from a struct are &quot;safely&quot; ignored","ref":"Haytni.Params.html#create/2","title":"Haytni.Params.create/2","type":"function"},{"doc":"Wraps params in an other Map with the stringified key as key Example: iex&gt; Elixir.Haytni.Params . wrap ( %{ &quot;email&quot; =&gt; %{ &quot;email&quot; =&gt; &quot;foo@bar.com&quot; , &quot;password&quot; =&gt; &quot;azerty&quot; } } , :session ) %{ &quot;session&quot; =&gt; %{ &quot;email&quot; =&gt; &quot;foo@bar.com&quot; , &quot;password&quot; =&gt; &quot;azerty&quot; } }","ref":"Haytni.Params.html#wrap/2","title":"Haytni.Params.wrap/2","type":"function"},{"doc":"Contains shared stuffs between Haytni base plugins. Mainly handle a message view/template which is intended to replace &quot;abusive&quot; Phoenix.Controller.put_flash/3 . put_flash stores messages in session and may have several issues: it can conflict if you use multiple tabs or instances of a same browser excessive reads/writes (depending on the backend) incompatible with HTTP caching","ref":"HaytniWeb.Shared.html","title":"HaytniWeb.Shared","type":"module"},{"doc":"Momorize the original HTTP referer by adding it to a changeset. Have to be called on new or edit action (not create nor update ).","ref":"HaytniWeb.Shared.html#add_referer_to_changeset/2","title":"HaytniWeb.Shared.add_referer_to_changeset/2","type":"function"},{"doc":"Add a back/cancel link for SharedView. NOTE: we do not use &quot;javascript:history.back()&quot; as default since this may be inappropriate with Content Security Policy (CSP). But user is free to use it by indicating it as value for default .","ref":"HaytniWeb.Shared.html#back_link/3","title":"HaytniWeb.Shared.back_link/3","type":"function"},{"doc":"Returns the path to a Haytni controller Example: iex&gt; Elixir.HaytniWeb.Shared . haytni_path ( conn , YourApp.Haytni , &amp; ( :&quot;haytni_ \#{ &amp;1 } _invitation_path&quot; ) , :new , [ [ invitation : &quot;ABCD&quot; , email : &quot;me@mydomain.com&quot; ] ] ) &quot;/invitations/new?invitation=ABCD&amp;email=me%40mydomain.com&quot;","ref":"HaytniWeb.Shared.html#haytni_path/5","title":"HaytniWeb.Shared.haytni_path/5","type":"function"},{"doc":"Add a next step link for SharedView.","ref":"HaytniWeb.Shared.html#next_step_link/3","title":"HaytniWeb.Shared.next_step_link/3","type":"function"},{"doc":"Set connection to render SharedView/message.html.","ref":"HaytniWeb.Shared.html#render_message/4","title":"HaytniWeb.Shared.render_message/4","type":"function"},{"doc":"Returns the path to the login page.","ref":"HaytniWeb.Shared.html#session_path/2","title":"HaytniWeb.Shared.session_path/2","type":"function"},{"doc":"","ref":"installation.html","title":"installation","type":"extras"},{"doc":"The package can be installed by adding haytni to your list of dependencies in mix.exs: def deps do [ # ... { :haytni , &quot;~&gt; 0.7.0&quot; } , # with bcrypt support (for past and/or present passwords) { :expassword_bcrypt , &quot;~&gt; 0.2&quot; } , # with argon2 support (for past and/or present passwords) \#{:expassword_argon2, &quot;~&gt; 0.2&quot;}, { :ecto_network , &quot;~&gt; 1.3.0&quot; } , # for TrackablePlugin only with PostgreSQL ] end Then run mix deps.get . Configure Haytni config/config.exs config :haytni , YourApp.Haytni , #layout: {YourAppWeb.LayoutView, :app}, #mailer: YourApp.Mailer, # see below otp_app : :your_app , repo : YourApp.Repo , schema : YourApp.User For testing, you may also want to add the following settings to config/test.exs : config :your_app , YourApp.Mailer , adapter : Bamboo.TestAdapter These are the mandatory options. See options of each plugin for full customizations. Run mix haytni.install which has the following options (command arguments): --table &lt;table&gt; (default: &quot;users&quot; ): the name of your table (used to generate migrations) --plugin Module1 --plugin Module2 ... --plugin ModuleN : the names of the (Elixir) modules/plugins to enable Create lib/ your_app _web/haytni.ex : defmodule YourApp.Haytni do use Haytni , otp_app : :your_app # with bcrypt to hash current passwords stack Haytni.AuthenticablePlugin , hashing_method : ExPassword.Bcrypt , hashing_options : %{ cost : ( if Mix . env ( ) == :test , do : 4 , else : 10 ) } # with argon2 to hash current passwords #stack Haytni.AuthenticablePlugin, hashing_method: ExPassword.Argon2, hashing_options: (if Mix.env() == :test, do: %{memory_cost: 256, threads: 1, time_cost: 2, type: :argon2id}, else: %{memory_cost: 131072, threads: 2, time_cost: 4, type: :argon2id}) stack Haytni.RegisterablePlugin stack Haytni.RememberablePlugin stack Haytni.ConfirmablePlugin stack Haytni.LockablePlugin stack Haytni.RecoverablePlugin #stack Haytni.TrackablePlugin stack Haytni.ClearSiteDataPlugin # add or remove/comment any plugin end Change lib/ your_app _web/router.ex defmodule YourAppWeb.Router do use YourAppWeb , :router require YourApp.Haytni # &lt;= add this line # ... pipeline :browser do # ... plug YourApp.Haytni # &lt;= add this line end scope &quot;/&quot; do # ... YourApp.Haytni . routes ( ) # &lt;= add this line end # ... end If you use Phoenix LiveView, you can include your Haytni stack as an on_mount callback to also handle the current user: defmodule YourAppWeb.Router do use YourAppWeb , :router require YourApp.Haytni # &lt;= add this line pipeline :browser do # ... plug YourApp.Haytni # &lt;= add this line end live_session ( ... , on_mount : [ YourApp.Haytni , # &lt;= add this line # your other on_mount callbacks ] ) do # your dead and live routes YourApp.Haytni . routes ( ) # &lt;= add this line end # ... end Note: YourApp.Haytni.on_mount/4 , like YourApp.Haytni.call/2 (acting as a Plug), just set the current user (if he is valid according to Haytni.Plugin.invalid?/3 ), if you need to restrict access, you need to do it after (with an other Plug or directly in the controller for a dead view vs a following on_mount/4 callback or by the live view itself) Change lib/ your_app /user.ex defmodule YourApp.User do require YourApp.Haytni # &lt;= add this line # ... schema &quot;...&quot; do # ... YourApp.Haytni . fields ( ) # &lt;= add this line end def create_registration_changeset ( struct = % __MODULE__ { } , params = %{ } ) do struct # add any needed field by registration from your own fields in the list below |&gt; Ecto.Changeset . cast ( params , [ :email , :password ] ) |&gt; YourApp.Haytni . validate_password ( ) # ... (your custom validations) ... |&gt; YourApp.Haytni . validate_create_registration ( ) end def update_registration_changeset ( struct = % __MODULE__ { } , params = %{ } ) do struct # put the names of the fields the user is allowed to change himself in the following empty list # but don&#39;t mention :email nor :password here, they are specifically handled by Haytni |&gt; Ecto.Changeset . cast ( params , [ ] ) # ... (your custom validations) ... |&gt; YourApp.Haytni . validate_update_registration ( ) end # ... end","ref":"installation.html#installation","title":"installation - Installation","type":"extras"},{"doc":"For plugins which send emails (Confirmable, Lockable and Recoverable): Create lib/mailer.ex as follows: defmodule YourApp.Mailer do use Bamboo.Mailer , otp_app : :your_app def from , do : { &quot;mydomain.com&quot; , &quot;noreply.mydomain.com&quot; } end Add to lib/ your_app _web/router.ex if Mix . env ( ) == :dev do Application . ensure_started ( :bamboo ) forward &quot;/sent_emails&quot; , Bamboo.SentEmailViewerPlug end Configure email sending in config/dev.exs: config :your_app , YourApp.Mailer , adapter : Bamboo.LocalAdapter config :haytni , YourApp.Haytni , mailer : YourApp.Mailer # &lt;= add/change this line For production (config/prod.exs), if you pass by your own SMTP server: config :your_app , YourApp.Mailer , adapter : Bamboo.SMTPAdapter , server : &quot;localhost&quot; , # the SMTP server is on the same host hostname : &quot;www.domain.com&quot; , port : 25 , tls : :never , no_mx_lookups : false , auth : :never And add {:bamboo_smtp, &quot;~&gt; 4.1&quot;, only: :prod} to deps in your mix.exs file. See Bamboo's documentation for details and other methods to send emails General configuration: layout (default: false for none): the layout to apply to Haytni's templates","ref":"installation.html#emails","title":"installation - Emails","type":"extras"},{"doc":"Functions you have to implement: for Registerable: YourApp.User .create_registration_changeset/2 and YourApp.User .update_registration_changeset/2 for sending emails (plugins Confirmable, Lockable and Recoverable): YourApp .Mailer.from/0","ref":"installation.html#quick-recap","title":"installation - Quick recap","type":"extras"},{"doc":"The file lib/ your_app /validations/forbidden_email_providers.txt will contain one provider (= what follows the @ character) by line to reject. Example: foo bar . com In the following implementation, the pattern &quot;foo&quot; wil be considered, comparatively to a regular expression (but we directly use pattern matching) to: ^foo.* on the hostname part of the email address. Create lib/ your_app /validations/email_provider_validation.ex with the following code: # lib/your_app/validations/email_provider_validation.ex defmodule YourApp.EmailProviderValidation do import Ecto.Changeset #import YourApp.Gettext @external_resource providers_path = Path . join ( [ __DIR__ , &quot;forbidden_email_providers.txt&quot; ] ) for line &lt;- File . stream! ( providers_path , [ ] , :line ) do provider = line |&gt; String . trim_trailing ( ) |&gt; String . downcase ( ) defp valid_email_provider? ( unquote ( provider ) &lt;&gt; _rest ) , do : false end defp valid_email_provider? ( _provider ) , do : true def validate_email_provider ( % Ecto.Changeset { valid? : true } = changeset , field ) when is_atom ( field ) do validate_change changeset , field , { :format , nil } , fn _ , value -&gt; [ _head , provider ] = value |&gt; String . downcase ( ) |&gt; String . split ( &quot;@&quot; , parts : 2 ) if valid_email_provider? ( provider ) do [ ] else [ { field , { &quot;%{provider} is not allowed&quot; , provider : provider , validation : :format } } ] # better if you translate it with (d)gettext end end end def validate_email_provider ( changeset = % Ecto.Changeset { } , _field ) , do : changeset end Then edit lib/ your_app /user.ex to add to the end of the functions validate_create_registration/2 and validate_update_registration/2 , the following line: |&gt; YourApp.EmailProviderValidation.validate_email_provider(:email) You can also write this functionnality as a plugin by implemenenting the validate_create_registration/2 and validate_update_registration/2 callbacks instead of modifying your lib/ your_app /user.ex. If so: # lib/your_app/haytni/refuse_disposable_email_plugin.ex defmodule YourApp.RefuseDisposableEmailPlugin do use Haytni.Plugin @impl Haytni.Plugin def validate_create_registration ( changeset = % Ecto.Changeset { } , _module , _config ) do changeset |&gt; YourApp.EmailProviderValidation ( :email ) end @impl Haytni.Plugin def validate_update_registration ( changeset = % Ecto.Changeset { } , _module , _config ) do changeset |&gt; YourApp.EmailProviderValidation ( :email ) end end And register YourApp.RefuseDisposableEmailPlugin to your Haytni stack in your lib/ your_app /haytni.ex: # lib/your_app/haytni.ex defmodule YourApp.Haytni do use Haytni , otp_app : :your_app # ... stack YourApp.RefuseDisposableEmailPlugin end Note: this implementation does not check that the email address has a valid format, you need to check this point before (with Ecto.Changeset.validate_format(changeset, :email, ~R/^[^@\\s]+@[^@\\s]+$/) for example). Haytni already does it in RegisterablePlugin so, if you use it as a plugin, just call yours after RegisterablePlugin.","ref":"block_disposable_email_addresses.html","title":"How to block disposable email addresses","type":"extras"},{"doc":"First add Haytni.LiveViewPlugin to your Haytni stack in lib/ your_app /haytni.ex by appending the following line: stack Haytni.LiveViewPlugin Then, in your endpoint (lib/your_app_web/endpoint.ex), you should find something like that: socket &quot;/socket&quot; , YourAppWeb.UserSocket , websocket : true , longpoll : false Make sure to change the true values here to [connect_info: [:peer_data, :x_headers]] . TODO (call from connect/3 callback) # lib/your_app_web/channels/user_socket.ex defmodule YourAppWeb.UserSocket do @impl Phoenix.Socket def connect ( params , socket , connect_info ) do Haytni.LiveViewPlugin . connect ( YourApp.Haytni , params , socket , connect_info ) end # ... end Now, in your javascript asset file, to acquire a token and reinject it to be granted to create a connection, use something like the following: fetch( '/token', { method: 'POST', headers: { 'Accept': 'application/json', }, } ) .then( response =&gt; response.json() ).then( token =&gt; { let socket = new Socket(&quot;/socket&quot;, {transport: WebSocket, params: {token: token}}) socket.connect() /* ... */ } ) fetch above can be replaced by a regular Ajax (XMLHttpRequest) call if your prefer. '/token' is the value of Routes.haytni_&lt;scope&gt;_token_path/[23] if you do a mix phx.routes . This path can overriden by the :token_path key when you call YourApp.Haytni.routes/1 in your router.","ref":"channels_and_live_view.html","title":"How to use with Channels or Live View?","type":"extras"},{"doc":"If Phoenix is behind nginx or any proxy Tokens for channels and liveview are short lived and validated against current IP address. But IP addresses from peer_data might be wrong if Phoenix does not directly handles HTTP and sockets. If this is your case, you need to specify the name (in lower case!) of the HTTP header your proxy follows you client addresses as :remote_ip_header option of stack Haytni.LiveViewPlugin . For example, if you use nginx and it is configured with: proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for; So you have to write: stack Haytni.LiveViewPlugin , remote_ip_header : &quot;x-forwarded-for&quot; Proper disconnection of channels and Live View For proper logout to channels and live view, you need to write the Phoenix.Socket.id/1 callback and, if last one does not return the string &quot;user_socket:\#{socket.assigns.current_&lt;scope&gt;.id}&quot; , you'll need to write a function somewhere and give it (via capture) as :socket_id option. Let's see an example: # lib/your_app_web/channels/user_socket.ex defmodule YourAppWeb.UserSocket do use Phoenix.Socket # ... @impl Phoenix.Socket def id ( socket ) do &quot;user_socket: \#{ socket . assigns . current_user . id } &quot; end end stack Haytni.LiveViewPlugin , socket_id : &amp; ( &quot;user_socket: \#{ &amp;1 . id } &quot; )","ref":"channels_and_live_view.html#configuration","title":"How to use with Channels or Live View? - Configuration","type":"extras"},{"doc":"Haytni does not directly handle account deletion (account removal) because everyone might want to do it in very different ways: delay it to give some time to the user to think about it and cancel it if wished confirm the action do some kind of soft-deletion instead remove extra data, even non-SQL ... So, it has to be written as a plugin which implements the Haytni.Plugin.on_delete_user/4 callback. Let's see some use cases as examples and guidelines.","ref":"delete_user.html","title":"How to delete a user","type":"extras"},{"doc":"To delete the user from the database (meaning issue a DELETE SQL statement), your Haytni.Plugin.on_delete_user/4 callback just need to add a c:Ecto.Multi.delete/4 operation to the Ecto.Multi received from its parameters : defmodule YourApp.HaytniPlugin do use Haytni.Plugin @impl Haytni.Plugin def on_delete_user ( multi = % Ecto.Multi { } , user = % _ { } , _module , _config ) do multi |&gt; Ecto.Multi . delete ( :deletion , user ) end end","ref":"delete_user.html#hard-deletion","title":"How to delete a user - Hard deletion","type":"extras"},{"doc":"The idea is the same but instead of deleting the user, we update ( c:Ecto.Multi.update/4 ) it to turn off some field and flag reflecting this state. defmodule YourApp.HaytniPlugin do use Haytni.Plugin @impl Haytni.Plugin def fields ( _module ) do quote do field :deleted , :boolean , default : true end end @impl Haytni.Plugin def invalid? ( user = % _ { } , _module , _config ) do user . deleted &amp;&amp; { :error , :deleted } end @impl Haytni.Plugin def on_delete_user ( multi = % Ecto.Multi { } , user = % _ { } , _module , _config ) do multi |&gt; Ecto.Multi . update ( :deletion , Ecto.Changeset . change ( user , [ deleted : true ] ) ) end end The callbacks Haytni.Plugin.fields/1 and Haytni.Plugin.invalid?/3 were also implemented to deal with this additional information.","ref":"delete_user.html#soft-deletion","title":"How to delete a user - Soft deletion","type":"extras"},{"doc":"In this scenario, the idea is to issue an UPDATE to nullify (at least) the password and email. defmodule YourApp.HaytniPlugin do use Haytni.Plugin @impl Haytni.Plugin def on_delete_user ( multi = % Ecto.Multi { } , user = % _ { } , _module , _config ) do multi |&gt; Ecto.Multi . update ( :deletion , Ecto.Changeset . change ( user , [ encrypted_password : nil , email : nil ] ) ) end end But don't forget to write a migration for encrypted_password and email to be nullable.","ref":"delete_user.html#anonymize-account","title":"How to delete a user - Anonymize account","type":"extras"},{"doc":"Create a migration to add a boolean field to your table: # priv/repo/migrations/`date &#39;+%Y%m%d%H%M%S&#39;`_add_banned_field.ex defmodule YourApp.AddBannedField do use Ecto.Migration def change do alter table ( &quot;users&quot; ) do add :banned , :boolean , null : false end end end Then write a plugin which implements the fields/1 to inject the banned column we created earlier and invalid?/3 callback to return an error: # lib/your_app/haytni/ban_plugin.ex defmodule YourApp.BanPlugin do use Haytni.Plugin #import YourApp.Gettext @impl Haytni.Plugin def fields ( _module ) do quote do field :banned , :boolean , default : false end end @impl Haytni.Plugin def invalid? ( % _ { banned : false } , _module , _config ) , do : false def invalid? ( % _ { } , _module , _config ) , do : { :error , &quot;your account has been banned&quot; } # better if you translate it with (d)gettext end Finally add YourApp.BanPlugin to your Haytni stack key in lib/ your_app /haytni.ex: # lib/your_app/haytni.ex defmodule YourApp.Haytni do use Haytni , otp_app : :your_app # ... stack YourApp.BanPlugin end (the part to turn it on or off in your admin panel is not shown - it's just a form/checkbox with a separate changeset function)","ref":"implement_banishment.html","title":"How to implement banishment","type":"extras"},{"doc":"","ref":"invitable_extra_operations.html","title":"How to realize extra operations with Invitable","type":"extras"},{"doc":"We first need to add a route for that, so in your router, add the following: # lib/your_app_web/router.ex resources &quot;/invitations&quot; , YourAppWeb.InvitationController , only : ~W[index]a (I voluntarily don't use get &quot;/invitations&quot;, YourAppWeb.InvitationController to have easier to add other actions) Next, in one of your contexts or a new one, add a function to get the invitations of a user: defmodule YourApp.Accounts do import Ecto.Query alias YourApp.Repo import Haytni.InvitablePlugin.QueryHelpers # ... @spec list_invitations ( user :: YourApp . user ) :: [ Haytni.InvitablePlugin . invitation ] def list_invitations ( user = % YourApp.User { } ) do user |&gt; invitations_from_user ( ) |&gt; preload ( [ :accepter ] ) |&gt; order_by ( [ desc : :sent_at ] ) |&gt; Repo . all ( ) end end So this way, you can easily add any filter (accepted or not, expired or not and so on) as pagination at any time. Finaly, we'll have to write this controller and index action: # lib/your_app_web/controllers/invitation_controller.ex defmodule YourAppWeb.InvitationController do use YourAppWeb , :controller def index ( conn , _params ) do if current_user = conn . assigns [ :current_user ] do conn |&gt; assign ( :invitations , Accounts . list_invitations ( current_user ) ) |&gt; render ( :index ) else { :error , :forbidden } # to be handled by an Action Fallback end end end If you need a starting point for the corresponding template, here it is: # lib/your_app_web/templates/invitation/index.html.heex &lt;%= if Enum.any?(@invitations) do %&gt; &lt;table&gt; &lt;thead&gt; &lt;tr&gt; &lt;th&gt;&lt;%= dgettext(&quot;myapp&quot;, &quot;Sent at&quot;) %&gt;&lt;/th&gt; &lt;th&gt;&lt;%= dgettext(&quot;myapp&quot;, &quot;Sent to&quot;) %&gt;&lt;/th&gt; &lt;th&gt;&lt;%= dgettext(&quot;myapp&quot;, &quot;Accepted at&quot;) %&gt;&lt;/th&gt; &lt;th&gt;&lt;%= dgettext(&quot;myapp&quot;, &quot;Accepted by&quot;) %&gt;&lt;/th&gt; &lt;th&gt;&lt;/th&gt; &lt;/tr&gt; &lt;/thead&gt; &lt;tbody&gt; &lt;%= for invitation &lt;- @invitations do %&gt; &lt;tr&gt; &lt;td&gt;&lt;%= invitation.sent_at %&gt;&lt;/td&gt; &lt;td&gt;&lt;%= invitation.sent_to %&gt;&lt;/td&gt; &lt;td&gt;&lt;%= if is_nil(invitation.accepted_at), do: &quot;-&quot;, else: invitation.accepted_at %&gt;&lt;/td&gt; &lt;td&gt;&lt;%= if is_nil(invitation.accepted_by), do: &quot;-&quot;, else: invitation.accepter.name %&gt;&lt;/td&gt; &lt;td&gt;&lt;%= if is_nil(invitation.accepted_by), do: link(dgettext(&quot;myapp&quot;, &quot;Revoke&quot;), to: Routes.invitation_path(@conn, :delete, invitation), method: :delete) %&gt;&lt;/td&gt; &lt;/tr&gt; &lt;% end %&gt; &lt;/tbody&gt; &lt;/table&gt; &lt;% else %&gt; &lt;p&gt;&lt;%= dgettext(&quot;myapp&quot;, &quot;You have not send any invitation for now.&quot;) %&gt;&lt;/p&gt; &lt;% end %&gt; &lt;p&gt; &lt;%= link dgettext(&quot;myapp&quot;, &quot;Do you have a friend you want to invite?&quot;), to: Routes.haytni_user_invitation_path(@conn, :new) %&gt; &lt;/p&gt; ## Delete a non-accepted invitation First, in your router, add a delete route: # lib/your_app_web/router.ex resources &quot;/invitations&quot; , YourAppWeb.InvitationController , only : ~W[delete]a Then, in one of your contexts or a new one, write a revoke_invitation like this one: defmodule YourApp.Accounts do import Ecto.Query alias YourApp.Repo import Haytni.InvitablePlugin.QueryHelpers # ... @spec revoke_invitation ( user :: YourApp.User , id :: any ) :: boolean def revoke_invitation ( user = % YourApp.User { } , id ) when not is_nil ( id ) do { count , nil } = user |&gt; invitations_from_user ( ) |&gt; and_where_not_accepted ( ) |&gt; and_where_id_equals ( id ) |&gt; Repo . delete_all ( ) 1 == count end end Lastly, write the delete action of your invitation controller based on this model: # lib/your_app_web/controllers/invitation_controller.ex defmodule YourAppWeb.InvitationController do use YourAppWeb , :controller def delete ( conn , %{ &quot;id&quot; =&gt; invitation_id } ) do if current_user = conn . assigns [ :current_user ] do Haytni.InvitablePlugin . revoke_invitation ( current_user , invitation_id ) conn |&gt; put_flash ( :info , &quot;Invitation has been successfully revoked&quot; ) |&gt; redirect ( to : &quot;/&quot; ) |&gt; halt ( ) else { :error , :forbidden } # to be handled by an Action Fallback end end end","ref":"invitable_extra_operations.html#list-invitations-sent-by-the-current-user","title":"How to realize extra operations with Invitable - List invitations sent by the current user","type":"extras"},{"doc":"In your templates, to know if the current user is currently authenticated, you just need to test the @current_user assign which is automaticaly set for you (if your scope is :admin , for exemple, use @current_admin instead of @current_user ). A typical use case is to handle the links register + login vs profile + logout: &lt;nav&gt; &lt;ul&gt; &lt;%= if @current_user do %&gt; &lt;%# if the user is connected, display links to edit his profile and logout %&gt; &lt;li&gt; &lt;%= link YourAppWeb.Gettext.dgettext(&quot;your_app&quot;, &quot;Profile&quot;), to: Routes.haytni_user_registration_path(@conn, :edit) %&gt; &lt;/li&gt; &lt;li&gt; &lt;%= link YourAppWeb.Gettext.dgettext(&quot;your_app&quot;, &quot;Logout&quot;), to: Routes.haytni_user_session_path(@conn, :delete), method: :delete %&gt; &lt;/li&gt; &lt;% else %&gt; &lt;%# if the user is not connected, display links to connect or register %&gt; &lt;li&gt; &lt;%= link Haytni.Gettext.dgettext(&quot;haytni&quot;, &quot;Sign in&quot;), to: Routes.haytni_user_session_path(@conn, :new) %&gt; &lt;/li&gt; &lt;li&gt; &lt;%= link Haytni.Gettext.dgettext(&quot;haytni&quot;, &quot;Sign up&quot;), to: Routes.haytni_user_registration_path(@conn, :new) %&gt; &lt;/li&gt; &lt;% end %&gt; &lt;/ul&gt; &lt;/nav&gt;","ref":"links.html","title":"How to generate (non-)connected links to users","type":"extras"},{"doc":"","ref":"set_user_locale.html","title":"How to set user's locale","type":"extras"},{"doc":"The first step would be to write a migration to add a field to your table in order to store users's locale and, if you want to, also its timezone: # priv/repo/migrations/`date &#39;+%Y%m%d%H%M%S&#39;`_user_locale_field.ex defmodule YourApp.UserLocaleField do use Ecto.Migration def change do alter table ( &quot;users&quot; ) do add :locale , :string add :timezone , :string # remove or comment if you don&#39;t need it end end end Then apply the very same migration by the mix ecto.migrate command. Next, you also need to define these field in your user schema by adding the following Ecto.Schema.field/3 : # lib/your_app/user.ex defmodule YourApp.User do # ... schema &quot;users&quot; do # ... field :locale , :string field :timezone , :string end # ... end Now let's write a custom plug to set the appropriate locale for translations: # lib/your_app_web/plugs/set_user_locale.ex defmodule YourAppWeb.SetUserLocalePlug do import Plug.Conn @supported_locales Gettext . known_locales ( YourAppWeb.Gettext ) @behaviour Plug @impl Plug def init ( _opts ) , do : nil @impl Plug def call ( conn = % Plug.Conn { assigns : %{ current_user : % YourApp.User { locale : locale } } } , _options ) when locale in @supported_locales do Gettext . put_locale ( locale ) conn end def call ( conn , _options ) do conn end end Add it to your :browser pipeline in your router but after calling your Haytni stack (the plug YourApp.Haytni line): # lib/your_app_web/router.ex # ... pipeline :browser do # ... plug YourApp.Haytni plug YourAppWeb.SetUserLocalePlug # &lt;= line to add end # ...","ref":"set_user_locale.html#general-setup","title":"How to set user's locale - General setup","type":"extras"},{"doc":"It could be more useful if user can actually change its locale but we haven't taking care of this for now so let's remedy this. We will begin by completing the template for editing registration: # lib/your_app_web/templates/haytni/registration/edit.html.heex (global) or lib/your_app_web/templates/haytni/user/registration/edit.html.heex (scoped) &lt;div&gt; &lt;%= label f, :locale, YourAppWeb.Gettext.dgettext(&quot;your_domain&quot;, &quot;Locale&quot;) %&gt; &lt;%= select f, :locale, Gettext.known_locales(YourAppWeb.Gettext) %&gt; &lt;%= error_tag f, :locale %&gt; &lt;/div&gt; &lt;div&gt; &lt;%= label f, :timezone, YourAppWeb.Gettext.dgettext(&quot;your_domain&quot;, &quot;Timezone&quot;) %&gt; &lt;%= select f, :timezone, Tzdata.zone_lists_grouped() %&gt; &lt;%= error_tag f, :timezone %&gt; &lt;/div&gt; Note : to support timezones, you'll need tzdata . To do so: add tzdata by the tuple {:tzdata, &quot;~&gt; 1.1&quot;} in the deps/0 function of your mix.exs file add config :elixir, :time_zone_database, Tzdata.TimeZoneDatabase in config/config.exs Finally, accept and validate those fields from the update_registration_changeset/2 function in the user schema: # lib/your_app/user.ex # function to add (only to support user&#39;s timezone) defp validate_timezone ( % Ecto.Changeset { } = changeset , field ) when is_atom ( field ) do validate_change changeset , field , { :inclusion , nil } , fn _ , value -&gt; if Tzdata . zone_exists? ( value ) do [ ] else [ { field , { &quot;is invalid&quot; , [ validation : :inclusion ] } } ] end end end def update_registration_changeset ( % __MODULE__ { } = struct , params ) do struct |&gt; cast ( params , ~W[locale timezone]a ) # &lt;= line to change |&gt; validate_inclusion ( :locale , Gettext . known_locales ( YourAppWeb.Gettext ) ) # &lt;= line to add |&gt; validate_timezone ( :timezone ) # &lt;= line to add (only needed for user to have a timezone) |&gt; YourApp.Haytni . validate_update_registration ( ) end ## Bonus : translating dates Start by adding :ex_cldr_dates_times as a dependency to your project (function deps/0 in your mix.exs file): # mix.exs { :ex_cldr_dates_times , &quot;~&gt; 2.0&quot; } , Configure, through config/config.exs the default locale and timezone as you want (french here): # config/config.exs config :your_app , default_locale : &quot;fr&quot; , default_timezone : &quot;Europe/Paris&quot; Create a module for Cldr: # lib/your_app/cldr.ex defmodule YourApp.Cldr do use Cldr , locales : Gettext . known_locales ( YourAppWeb.Gettext ) , providers : [ Cldr.Number , Cldr.Calendar , Cldr.DateTime , ] end Now, you can run mix deps.get and restart your application. In a global (= imported everywhere via the function view/0 or view_helpers/0 of lib/your_app_web.ex) view add the following l/2 function: defp do_l ( dt = % DateTime { } , timezone , locale ) do dt |&gt; DateTime . shift_zone! ( timezone ) |&gt; YourApp.Cldr.DateTime . to_string! ( format : :long , locale : locale ) end def l ( dt = % DateTime { } , user = % User { } ) do do_l ( dt , user . timezone , user . locale ) end def l ( dt = % DateTime { } , nil ) do do_l ( dt , Application . fetch_env! ( :your_app , :default_timezone ) , Application . fetch_env! ( :your_app , :default_locale ) ) end Example of uses (in a template): &lt; % = l ( ~U[2018-07-16 10:00:00Z] , @current_user ) % &gt; &lt; % = l ( @post . created_at , @current_user ) % &gt;","ref":"set_user_locale.html#profile-edition","title":"How to set user's locale - Profile edition","type":"extras"},{"doc":"","ref":"trackable_extra_operations.html","title":"How to realize extra operations with Trackable","type":"extras"},{"doc":"In your &quot;user&quot; context: alias YourApp.Repo def user_connections ( user ) do user |&gt; Haytni.TrackablePlugin.QueryHelpers . connections_from_user ( ) |&gt; Repo . all ( ) # paginate if you want/like end In your controller: def index ( conn , _params ) do if current_user = conn . assigns [ :current_user ] do conn # ... |&gt; assign ( :connections , user_connections ( current_user ) ) |&gt; render ( :index ) else { :error , :forbidden } end end Part of the template: &lt;ul&gt; &lt;%= for connection &lt;- @connections do %&gt; &lt;li&gt;&lt;%= c.ip %&gt; (&lt;%= c.inserted_at %&gt;)&lt;/li&gt; &lt;% end %&gt; &lt;/ul&gt; ## Search who used an IP address First, to have easier to handle the form for search and maintain/enhance it, we will introduce a schema less module called YourApp.Admin.IpSearch : # lib/your_app/admin/ipsearch.ex defmodule YourApp.Admin.IpSearch do import Ecto.Changeset @types %{ ip : :string , first : :utc_datetime , last : :utc_datetime , } @attributes Map . keys ( @types ) defstruct @attributes @required ~W[ip]a def changeset ( % __MODULE__ { } = struct , params \\\\ %{ } ) do { struct , @types } |&gt; Ecto.Changeset . cast ( params , @attributes ) |&gt; validate_required ( @required ) |&gt; validate_ipaddress ( :ip ) end end Create an admin context or reuse one where we will implement the functions change_ipsearch/[01] , create_ipsearch/1 , find_by_ip/1 : # lib/your_app/admin/admin.ex defmodule YourApp.Admin do import Ecto.Query , warn : false alias YourApp.Repo alias YourApp.Admin.IpSearch def change_ipsearch do change_ipsearch ( % IpSearch { } ) end def change_ipsearch ( % IpSearch { } = search ) do IpSearch . changeset ( search , %{ } ) end def create_ipsearch ( attrs \\\\ %{ } ) do % IpSearch { } |&gt; IpSearch . changeset ( attrs ) |&gt; Ecto.Changeset . apply_action ( :insert ) end def find_by_ip ( search = % IpSearch { } ) do import Haytni.TrackablePlugin.QueryHelpers % User { } |&gt; connections_from_all ( ) |&gt; and_where_ip_equals ( search . ip ) |&gt; and_where_date_between ( search . first , search . last ) |&gt; preload ( [ :user ] ) |&gt; order_by ( [ desc : :inserted_at ] ) |&gt; Repo . all ( ) end end Then here is the controller: # lib/your_app_web/controllers/admin/ip_search_controller.ex defmodule YourAppWeb.Admin.IpSearchController do use YourAppWeb , :controller alias YourApp.Repo alias YourApp.User alias YourApp.Admin defp render_new ( conn , % Ecto.Changeset { } = changeset ) do conn |&gt; assign ( :changeset , changeset ) |&gt; render ( :new ) end def new ( conn , _params ) do render_new ( conn , Admin . change_ipsearch ( ) ) end def create ( conn , params ) do search_params |&gt; Admin . create_ipsearch ( ) |&gt; case do { :ok , search } -&gt; conn |&gt; assign ( :search , search ) |&gt; assign ( :results , Admin . find_by_ip ( search ) ) |&gt; render ( :create ) { :error , changeset } -&gt; render_new ( conn , changeset ) end end end The new template: # lib/your_app_web/templates/admin/ip_search/new.html.heex &lt;%= form_for @changeset, Routes.admin_ip_search_path(@conn, :create), [as: :search], fn f -&gt; %&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= label f, :ip %&gt; &lt;%= text_input f, :ip %&gt; &lt;%= error_tag f, :ip %&gt; &lt;/div&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= label f, :first %&gt; &lt;%= datetime_select f, :first %&gt; &lt;%= error_tag f, :first %&gt; &lt;/div&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= label f, :last %&gt; &lt;%= datetime_select f, :last %&gt; &lt;%= error_tag f, :last %&gt; &lt;/div&gt; &lt;br/&gt; &lt;%= submit &quot;Search&quot; %&gt; &lt;% end %&gt; The create template: # lib/your_app_web/templates/admin/ip_search/create.html.heex &lt;h2&gt;Results for &lt;b&gt;&lt;%= @search.ip %&gt;&lt;/b&gt;&lt;/h2&gt; &lt;%= if Enum.empty?(@results) do %&gt; &lt;p&gt;This address has not been used&lt;/p&gt; &lt;% else %&gt; &lt;p&gt;&lt;%= Enum.count(@results) %&gt; résult(s) found.&lt;/p&gt; &lt;table&gt; &lt;thead&gt; &lt;tr&gt; &lt;th&gt;Address&lt;/th&gt; &lt;th&gt;When&lt;/th&gt; &lt;th&gt;User&lt;/th&gt; &lt;/tr&gt; &lt;/thead&gt; &lt;tbody&gt; &lt;%= for r &lt;- @results do %&gt; &lt;tr&gt; &lt;td&gt;&lt;%= r.ip %&gt;&lt;/td&gt; &lt;td&gt;&lt;%= r.inserted_at %&gt;&lt;/td&gt; &lt;td&gt;&lt;%= link r.user.name, to: Routes.admin_user_path(@conn, :show, r.user) %&gt;&lt;/td&gt; &lt;/tr&gt; &lt;% end %&gt; &lt;/tbody&gt; &lt;/table&gt; &lt;% end %&gt; The route, according to the previous codes, would be: # lib/your_app_web/router.ex defmodule YourAppWeb.Router do use YourAppWeb , :router require YourAppWeb.Haytni # ... scope &quot;/back&quot; , as : :admin do # ... resources &quot;/ipsearch&quot; , YourAppWeb.Admin.IpSearchController , only : ~W[new create]a end end The empty view just as remainder to not forget it: # lib/your_app_web/views/admin/ip_search_view.ex defmodule YourAppWeb.Admin.IpSearchView do use YourAppWeb , :view end NOTE: the plug to restrict access to the YourAppWeb.Admin.IpSearchController controller is not shown","ref":"trackable_extra_operations.html#list-all-connections-of-the-current-user","title":"How to realize extra operations with Trackable - List (all) connections of the current user","type":"extras"}]